<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2004-06-21 01:50:00'
LAST_UPDATE='2021-11-28 13:49:11'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-wsdldoc'
APP_NAME='FlexDoc/XML WSDLDoc'
APP_VER='1.2.5'
APP_AUTHOR='Copyright © 2012-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='wsdldoc'
ROOT_ET='#DOCUMENTS'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$nsURI';
		param.title='Namespace URI';
		param.type='string';
	}
	PARAM={
		param.name='$compact';
		param.description='Print namespace profile in a compact form';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.type='boolean';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs2';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='Hyperlink (latent)';
		style.id='cs3';
		text.decor.underline='true';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Profile Item';
		style.id='cs4';
		style.description='The text of schema/namespace profile item.';
		style.css.className='profileItem';
		text.font.name='Verdana';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='Profile Item Title';
		style.id='ps2';
		style.description='Formats the title of schema/namespace profile item.

NOTE: Some of such titles can be simultaneously latent hyperlinks (which reveal themselves only when mouse cursor hovers over the heading). So, when rendered in HTML, this style may produce two named CSS rules: one for <div> element (to format the title paragraph) and other for <span> and <a> elements (to format the title text and the hyperlink). At that, in case of hyperlink, any default hyperlink formatting must be suppressed and normal title formatting preserved. That is achieved by specifically setting: no underline; black color';
		style.css.className='profileItemTitle';
		text.font.size='9';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
	}
	PAR_STYLE={
		style.name='Property Title';
		style.id='ps3';
		text.font.size='8';
		text.font.style.bold='true';
		par.lineHeight='11';
		par.margin.right='5.8';
	}
	PAR_STYLE={
		style.name='Property Value';
		style.id='ps4';
		text.font.name='Verdana';
		text.font.size='8';
		par.lineHeight='11';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs2';
}
<ROOT>
	<FOLDER>
		DESCR='COMPACT FORM (when included in namespace summary)'
		COND='getBooleanParam("$compact")'
		BREAK_PARENT_BLOCK='when-executed'
		FMT={
			sec.outputStyle='table';
			table.cell.padding.both='0';
			table.border.style='none';
			table.page.keepTogether='true';
		}
		<BODY>
			<AREA_SEC>
				COND='count = countElementsByKey (
  "namespaces",
  getParam("$nsURI"),
  BooleanQuery (instanceOf ("wsdl:definitions"))
);

(count > 0) ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<PANEL>
								FMT={
									ctrl.size.width='171';
									ctrl.size.height='38.3';
									tcell.align.vert='Top';
									txtfl.separator.type='text';
									txtfl.separator.text=', ';
									par.style='ps3';
								}
								<AREA>
									<CTRL_GROUP>
										FMT={
											txtfl.separator.type='none';
										}
										<CTRLS>
											<DATA_CTRL>
												EXPR='"WSDL Files (" + getVar("count") + ")"'
												FMT={
													text.hlink.fmt='style';
													text.hlink.style='cs3';
													text.hlink.style.use='hover';
												}
												<DOC_HLINK>
													TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
													HKEYS={
														'getStringParam("$nsURI")';
														'"ns-wsdl-file-summary"';
													}
												</DOC_HLINK>
											</DATA_CTRL>
											<TEXT_CTRL>
												TEXT=':'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
							<SS_CALL_CTRL>
								SS_NAME='WSDL Files'
								FMT={
									ctrl.size.width='328.5';
									ctrl.size.height='38.3';
									par.style='ps4';
								}
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='checkStockSectionOutput("WSDL Definitions")'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='WSDL Definitions:'
								FMT={
									ctrl.size.width='171';
									ctrl.size.height='18';
									tcell.align.vert='Top';
									par.style='ps3';
								}
							</TEXT_CTRL>
							<SS_CALL_CTRL>
								SS_NAME='WSDL Definitions'
								FMT={
									ctrl.size.width='328.5';
									ctrl.size.height='18';
									par.style='ps4';
								}
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='count = countElementsByKey (
  "namespaces",
  getParam("$nsURI"),
  BooleanQuery (instanceOf ("xs:schema"))
);

(count > 0) ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<PANEL>
								FMT={
									ctrl.size.width='171';
									ctrl.size.height='38.3';
									tcell.align.vert='Top';
									txtfl.separator.type='text';
									txtfl.separator.text=', ';
									par.style='ps3';
								}
								<AREA>
									<CTRL_GROUP>
										FMT={
											txtfl.separator.type='none';
										}
										<CTRLS>
											<DATA_CTRL>
												EXPR='"XML Schemas (" + getVar("count") + ")"'
												FMT={
													text.hlink.fmt='style';
													text.hlink.style='cs3';
													text.hlink.style.use='hover';
												}
												<DOC_HLINK>
													TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
													HKEYS={
														'getStringParam("$nsURI")';
														'"ns-schema-summary"';
													}
												</DOC_HLINK>
											</DATA_CTRL>
											<TEXT_CTRL>
												TEXT=':'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
							<SS_CALL_CTRL>
								SS_NAME='Schemas'
								FMT={
									ctrl.size.width='328.5';
									ctrl.size.height='38.3';
									par.style='ps4';
								}
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='checkStockSectionOutput("XSD Components")'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='XSD Components:'
								FMT={
									ctrl.size.width='171';
									ctrl.size.height='18';
									tcell.align.vert='Top';
									par.style='ps3';
								}
							</TEXT_CTRL>
							<SS_CALL_CTRL>
								SS_NAME='XSD Components'
								FMT={
									ctrl.size.width='328.5';
									ctrl.size.height='18';
									par.style='ps4';
								}
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
	<FOLDER>
		DESCR='EXTENDED FORM (when included in Namespace Overview)'
		<BODY>
			<ELEMENT_ITER>
				DESCR='WSDL files targeting this namespace'
				TARGET_ET='wsdl:definitions'
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='findElementsByKey ("namespaces", getParam("$nsURI"))'
				SORTING='by-expr'
				SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
				FMT={
					sec.outputStyle='list';
					sec.spacing.before='5';
					list.type='delimited';
					list.indent.block='true';
				}
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<AREA>
							<CTRL_GROUP>
								FMT={
									text.style='cs1';
									txtfl.separator.type='none';
								}
								<CTRLS>
									<DATA_CTRL>
										EXPR='"Targeting WSDL Files (" + iterator.numItems + ")"'
										FMT={
											text.hlink.fmt='style';
											text.hlink.style='cs3';
											text.hlink.style.use='hover';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
											HKEYS={
												'getStringParam("$nsURI")';
												'"ns-wsdl-file-summary"';
											}
										</DOC_HLINK>
									</DATA_CTRL>
									<TEXT_CTRL>
										TEXT=':'
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<AREA_SEC>
						FMT={
							text.style='cs4';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<SS_CALL_CTRL>
										SS_NAME='WSDL Name'
									</SS_CALL_CTRL>
									<SEPARATOR>
										FMT={
											txtfl.separator.type='text';
											txtfl.separator.text=', ';
										}
									</SEPARATOR>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
			<FOLDER>
				DESCR='all WSDL definitions in this namespace'
				FMT={
					sec.spacing.before='5';
				}
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										TEXT='WSDL Definitions:'
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='WSDL Definitions'
						FMT={
							sec.outputStyle='text-par';
							sec.indent.block='true';
							text.style='cs4';
							txtfl.separator.type='text';
							txtfl.separator.text=', ';
						}
					</SS_CALL>
				</BODY>
			</FOLDER>
			<ELEMENT_ITER>
				DESCR='XML schemas targeting this namespace'
				TARGET_ET='xs:schema'
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='findElementsByKey ("namespaces", getParam("$nsURI"))'
				SORTING='by-expr'
				SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
				FMT={
					sec.outputStyle='list';
					sec.spacing.before='5';
					list.type='delimited';
					list.indent.block='true';
				}
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<AREA>
							<CTRL_GROUP>
								FMT={
									txtfl.separator.type='none';
								}
								<CTRLS>
									<DATA_CTRL>
										EXPR='"Targeting XML Schemas (" + iterator.numItems + ")"'
										FMT={
											text.hlink.fmt='style';
											text.hlink.style='cs3';
											text.hlink.style.use='hover';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
											HKEYS={
												'getStringParam("$nsURI")';
												'"ns-schema-summary"';
											}
										</DOC_HLINK>
									</DATA_CTRL>
									<TEXT_CTRL>
										TEXT=':'
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<AREA_SEC>
						FMT={
							text.style='cs4';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<SS_CALL_CTRL>
										SS_NAME='Schema Name'
									</SS_CALL_CTRL>
									<SEPARATOR>
										FMT={
											txtfl.separator.type='text';
											txtfl.separator.text=', ';
										}
									</SEPARATOR>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
			<FOLDER>
				DESCR='all XSD components defined in this namespace'
				FMT={
					sec.spacing.before='5';
				}
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										TEXT='XSD Components:'
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='XSD Components'
						FMT={
							sec.outputStyle='text-par';
							sec.indent.block='true';
							text.style='cs4';
							txtfl.separator.type='text';
							txtfl.separator.text=', ';
						}
					</SS_CALL>
				</BODY>
			</FOLDER>
		</BODY>
	</FOLDER>
</ROOT>
<STOCK_SECTIONS>
	<TEMPLATE_CALL>
		SS_NAME='Schema Name'
		MATCHING_ET='xs:schema'
		TEMPLATE_FILE='../xsd/schema/schemaName.tpl'
	</TEMPLATE_CALL>
	<ELEMENT_ITER>
		SS_NAME='Schemas'
		DESCR='XML schemas targeting this namespace'
		TARGET_ET='xs:schema'
		SCOPE='custom'
		ELEMENT_ENUM_EXPR='findElementsByKey ("namespaces", getParam("$nsURI"))'
		SORTING='by-expr'
		SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
		FMT={
			sec.outputStyle='list';
			list.type='delimited';
		}
		<BODY>
			<SS_CALL>
				SS_NAME='Schema Name'
			</SS_CALL>
		</BODY>
	</ELEMENT_ITER>
	<FOLDER>
		SS_NAME='WSDL Definitions'
		DESCR='all WSDL definitions in this namespace'
		FMT={
			sec.outputStyle='text-par';
			txtfl.separator.type='text';
			txtfl.separator.text=', ';
		}
		<BODY>
			<AREA_SEC>
				DESCR='global attributes'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::wsdl:definitions / wsdl:service\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='services'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-service-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='global attributes'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::wsdl:definitions / wsdl:binding\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='bindings'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-binding-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='global attributes'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::wsdl:definitions / wsdl:portType\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='portTypes'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-portType-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='global attributes'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::wsdl:definitions / wsdl:message\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='messages'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-message-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
	<ELEMENT_ITER>
		SS_NAME='WSDL Files'
		DESCR='WSDL files targeting this namespace'
		TARGET_ET='wsdl:definitions'
		SCOPE='custom'
		ELEMENT_ENUM_EXPR='findElementsByKey ("namespaces", getParam("$nsURI"))'
		SORTING='by-expr'
		SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
		FMT={
			sec.outputStyle='list';
			list.type='delimited';
		}
		<BODY>
			<SS_CALL>
				SS_NAME='WSDL Name'
			</SS_CALL>
		</BODY>
	</ELEMENT_ITER>
	<TEMPLATE_CALL>
		SS_NAME='WSDL Name'
		MATCHING_ET='wsdl:definitions'
		TEMPLATE_FILE='../wsdl/file/wsdlName.tpl'
	</TEMPLATE_CALL>
	<FOLDER>
		SS_NAME='XSD Components'
		DESCR='all XSD components defined in this namespace'
		FMT={
			sec.outputStyle='text-par';
			txtfl.separator.type='text';
			txtfl.separator.text=', ';
		}
		<BODY>
			<AREA_SEC>
				DESCR='elements'
				COND='global_count = countElementsByLPath(
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::xs:schema / xs:element\'
);

(nsURI = getStringParam("$nsURI")) != "" ?
{
  local_count = countElementsByLPath (
    \'{findElementsByKey ("namespaces", nsURI)}::xs:schema / descendant::xs:%localElement\',
    BooleanQuery (
      ! hasAttr("ref") &&
      {
        form = hasAttr("form") ? getAttrValue("form") :
                 findPredecessorByType("xs:schema").getAttrStringValue ("elementFormDefault");

        (form == "qualified")
      }
    )
  )
} : {

  local_count = countElementsByLPath (
    \'{findElementsByKey ("namespaces", "")}::xs:schema / descendant::xs:%localElement\',
    BooleanQuery (
      ! hasAttr("ref")
    )
  ) + countElementsByKey ("namespaces", "", BooleanQuery (instanceOf ("xs:%localElement")))
};

global_count + local_count > 0 ? { 
  setVar ("global_count", global_count);
  setVar ("local_count", local_count);
  true 
} : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='elements'
								FMT={
									text.spacing.nbsp='true';
								}
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"element-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<TEXT_CTRL>
								TEXT='('
							</TEXT_CTRL>
							<SEPARATOR>
								FMT={
									txtfl.separator.type='none';
								}
							</SEPARATOR>
							<PANEL>
								COND='findHyperTarget (
  Array (
    getStringParam("$nsURI"),
    "top-level-element-summary"
  )
) != null'
								FMT={
									ctrl.size.width='147.8';
									txtfl.separator.type='none';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<TEXT_CTRL>
												TEXT='top-level'
												<DOC_HLINK>
													HKEYS={
														'getStringParam("$nsURI")';
														'"top-level-element-summary"';
													}
												</DOC_HLINK>
											</TEXT_CTRL>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='text';
													txtfl.separator.text=' / ';
												}
											</SEPARATOR>
											<TEXT_CTRL>
												COND='findHyperTarget (
  Array (
    getStringParam("$nsURI"),
    "other-element-summary"
  )
) != null'
												TEXT='other'
												<DOC_HLINK>
													HKEYS={
														'getStringParam("$nsURI")';
														'"other-element-summary"';
													}
												</DOC_HLINK>
											</TEXT_CTRL>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='none';
												}
											</SEPARATOR>
											<TEXT_CTRL>
												TEXT=';'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
							<PANEL>
								COND='getVar("global_count").toInt() > 0'
								FMT={
									ctrl.size.width='163.5';
									ctrl.size.height='38.3';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<DATA_CTRL>
												EXPR='getVar("global_count")'
											</DATA_CTRL>
											<TEXT_CTRL>
												TEXT='global'
											</TEXT_CTRL>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='nbtxt';
													txtfl.separator.text=' + ';
												}
											</SEPARATOR>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
							<PANEL>
								COND='getVar("local_count").toInt() > 0'
								FMT={
									ctrl.size.width='139.5';
									ctrl.size.height='38.3';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<DATA_CTRL>
												EXPR='getVar("local_count")'
											</DATA_CTRL>
											<TEXT_CTRL>
												TEXT='local'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
							<SEPARATOR>
								FMT={
									txtfl.separator.type='none';
								}
							</SEPARATOR>
							<TEXT_CTRL>
								TEXT=')'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='complexTypes'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::xs:schema /
   descendant::xs:complexType\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='complexTypes'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-complexType-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='simpleTypes'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::xs:schema /
   descendant::xs:simpleType\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='simpleTypes'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-simpleType-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='element groups'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::xs:schema /
   descendant::xs:group\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='element groups'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-group-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='global attributes'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::xs:schema / xs:attribute\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='global attributes'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-attribute-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				DESCR='attribute groups'
				COND='count = countElementsByLPath (
  \'{findElementsByKey ("namespaces", getParam("$nsURI"))}::xs:schema /
   descendant::xs:attributeGroup\'
);

count > 0 ? { setVar ("count", count); true } : false'
				<AREA>
					<CTRL_GROUP>
						FMT={
							text.spacing.nbsp='true';
							txtfl.separator.type='nbsp';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='attribute groups'
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary" : ""'
									HKEYS={
										'getStringParam("$nsURI")';
										'"ns-attributeGroup-summary"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='\'(\' + getVar("count") + \')\''
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
</STOCK_SECTIONS>
CHECKSUM='WHnx7vRLkipsdYLBtcy?IMyj1g+VCmqFl4Zbii6u7nM'
</FLEXDOCXYZ_TEMPLATE>