<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2014-10-05 21:46:59'
LAST_UPDATE='2021-11-28 13:49:11'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-wsdldoc'
APP_NAME='FlexDoc/XML WSDLDoc'
APP_VER='1.2.5'
APP_AUTHOR='Copyright © 2012-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='wsdldoc'
ROOT_ETS={'wsdl:fault%wsdl:tFault';'wsdl:input%wsdl:tParam';'wsdl:output%wsdl:tParam'}
INIT_EXPR='mainXMLFilter = BooleanQuery (
  checkElementByKey (
    "main-xmls",
    getXMLDocument().id,
    getElementParam("$mainXML")
  )
);

getAttrStringValue("element") != "" ?
{
  element = findElementByKey (
    "xsd-global-elements",
    getAttrQNameValue("element"),
    mainXMLFilter
  );

  thisContext.setVar ("element", element);

  thisContext.setVar (
    "elementType",
    findElementByKey ("xsd-element-types", element.id)
  )
};

getAttrStringValue("type") != "" ?
{
  thisContext.setVar (
    "type",
    findElementByKey (
      "xsd-types",
      getAttrQNameValue("type"),
      mainXMLFilter
    )
  )
}'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$mainXML';
		param.type='GOMElement';
		param.defaultValue.expr='findElementByKey ("main-xmls", getXMLDocument().id)';
	}
	PARAM={
		param.name='$resourceOutputDir';
		param.title='documentation resources directory';
		param.type='string';
	}
	PARAM={
		param.name='$message';
		param.type='GOMElement';
		param.defaultValue.expr='findElementByKey (
  "wsdl-messages",
  getAttrQNameValue("message"),
  BooleanQuery (checkElementByKey (
    "main-xmls",
    getXMLDocument().id,
    getElementParam("$mainXML")
  ))
)';
	}
	PARAM={
		param.name='parts';
		param.title='Parts';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='parts.description';
		param.title='Description';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='parts.description.copyFrom';
		param.title='Copy From';
		param.title.style.italic='true';
		param.group='true';
	}
	PARAM={
		param.name='parts.description.copyFrom.dataType';
		param.title='Data Type';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.icons';
		param.title='Icons';
		param.type='boolean';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.type='boolean';
	}
	PARAM={
		param.name='page';
		param.title='Pagination';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='page.refs';
		param.title='Generate page references';
		param.type='boolean';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Derivation Method';
		style.id='cs2';
		text.font.name='Verdana';
		text.font.size='8';
		text.color.foreground='#FF9900';
	}
	CHAR_STYLE={
		style.name='Description (Small)';
		style.id='cs3';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs4';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='Mono (Small)';
		style.id='cs5';
		text.font.name='Courier New';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Page Reference';
		style.id='cs6';
		text.font.name='Courier New';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='Property Title';
		style.id='ps2';
		text.font.size='8';
		text.font.style.bold='true';
		par.lineHeight='11';
		par.margin.right='6';
	}
	CHAR_STYLE={
		style.name='Property Value Font';
		style.id='cs7';
		text.font.name='Verdana';
		text.font.size='8';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs4';
}
<ROOT>
	<FOLDER>
		DESCR='with icons'
		COND='getBooleanParam("show.icons")'
		BREAK_PARENT_BLOCK='when-executed'
		FMT={
			sec.outputStyle='table';
			table.cell.padding.both='0';
			table.border.style='none';
			table.page.keepTogether='true';
		}
		<BODY>
			<AREA_SEC>
				FMT={
					trow.cell.align.vert='Top';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Message:'
								FMT={
									ctrl.size.width='44.3';
									ctrl.size.height='59.3';
									tcell.sizing='Minimal';
									par.style='ps2';
								}
							</TEXT_CTRL>
							<IMAGE_CTRL>
								IMAGE_TYPE='file-image'
								FILE='../../images/message.png'
								OUTPUT_DIR_EXPR='getStringParam("$resourceOutputDir")'
								FMT={
									ctrl.size.width='21';
									ctrl.size.height='59.3';
									image.alignment='bottom';
									image.padding.right='2';
									tcell.sizing='Minimal';
									tcell.width='16';
								}
							</IMAGE_CTRL>
							<PANEL>
								FMT={
									ctrl.size.width='434.3';
									ctrl.size.height='59.3';
									tcell.align.vert='Center';
									text.style='cs7';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<DATA_CTRL>
												ATTR='message'
												FMT={
													text.style='cs5';
												}
												<DOC_HLINK>
													CONTEXT_ELEMENT_EXPR='getElementParam("$message")'
													MATCHING_ET='wsdl:message'
													TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("WSDL Definition Link Title")'
													HKEYS={
														'contextElement.id';
														'"detail"';
													}
												</DOC_HLINK>
											</DATA_CTRL>
											<PANEL>
												COND='output.format.supportsPageRefs
&&
getBooleanParam("page.refs")
&&
findHyperTarget (Array (
  getElementParam("$message").id,
  "detail"
)) != null'
												FMT={
													ctrl.size.width='145.5';
													ctrl.size.height='38.3';
													text.style='cs6';
													txtfl.separator.type='none';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																TEXT='['
															</TEXT_CTRL>
															<DATA_CTRL>
																DOCFIELD='page-htarget'
																FMT={
																	ctrl.option.noHLinkFmt='true';
																	text.hlink.fmt='none';
																}
																<DOC_HLINK>
																	CONTEXT_ELEMENT_EXPR='getElementParam("$message")'
																	MATCHING_ET='wsdl:message'
																	HKEYS={
																		'contextElement.id';
																		'"detail"';
																	}
																</DOC_HLINK>
															</DATA_CTRL>
															<TEXT_CTRL>
																TEXT=']'
															</TEXT_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='getBooleanParam("parts")
&&
getElementParam("$message").hasChild("wsdl:part")'
				CONTEXT_ELEMENT_EXPR='getElementParam("$message")'
				MATCHING_ET='wsdl:message'
				FMT={
					trow.cell.align.vert='Top';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Parts:'
								FMT={
									ctrl.size.width='44.3';
									ctrl.size.height='18';
									tcell.sizing='Minimal';
									tcell.align.vert='Top';
									par.style='ps2';
								}
							</TEXT_CTRL>
							<TEXT_CTRL>
								TEXT=''
								FMT={
									ctrl.size.width='21';
									ctrl.size.height='18';
									ctrl.option.text.noEmptyOutput='true';
									tcell.sizing='Minimal';
									tcell.width='16';
								}
							</TEXT_CTRL>
							<SS_CALL_CTRL>
								SS_NAME='parts'
								FMT={
									ctrl.size.width='434.3';
									ctrl.size.height='18';
								}
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
	<FOLDER>
		DESCR='without icons'
		FMT={
			sec.outputStyle='table';
			table.cell.padding.both='0';
			table.border.style='none';
			table.page.keepTogether='true';
		}
		<BODY>
			<AREA_SEC>
				FMT={
					trow.cell.align.vert='Top';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Message:'
								FMT={
									ctrl.size.width='44.3';
									ctrl.size.height='59.3';
									tcell.sizing='Minimal';
									par.style='ps2';
								}
							</TEXT_CTRL>
							<PANEL>
								FMT={
									ctrl.size.width='455.3';
									ctrl.size.height='59.3';
									tcell.align.vert='Center';
									text.style='cs7';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<DATA_CTRL>
												ATTR='message'
												FMT={
													text.style='cs5';
												}
												<DOC_HLINK>
													CONTEXT_ELEMENT_EXPR='getElementParam("$message")'
													MATCHING_ET='wsdl:message'
													TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("WSDL Definition Link Title")'
													HKEYS={
														'contextElement.id';
														'"detail"';
													}
												</DOC_HLINK>
											</DATA_CTRL>
											<PANEL>
												COND='output.format.supportsPageRefs
&&
getBooleanParam("page.refs")
&&
findHyperTarget (Array (
  getElementParam("$message").id,
  "detail"
)) != null'
												FMT={
													ctrl.size.width='145.5';
													ctrl.size.height='38.3';
													text.style='cs6';
													txtfl.separator.type='none';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																TEXT='['
															</TEXT_CTRL>
															<DATA_CTRL>
																DOCFIELD='page-htarget'
																FMT={
																	ctrl.option.noHLinkFmt='true';
																	text.hlink.fmt='none';
																}
																<DOC_HLINK>
																	CONTEXT_ELEMENT_EXPR='getElementParam("$message")'
																	MATCHING_ET='wsdl:message'
																	HKEYS={
																		'contextElement.id';
																		'"detail"';
																	}
																</DOC_HLINK>
															</DATA_CTRL>
															<TEXT_CTRL>
																TEXT=']'
															</TEXT_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<ELEMENT_ITER>
				COND='getBooleanParam("parts")'
				CONTEXT_ELEMENT_EXPR='getElementParam("$message")'
				MATCHING_ET='wsdl:message'
				TARGET_ET='wsdl:part'
				SCOPE='simple-location-rules'
				RULES={
					'* -> wsdl:part';
				}
				<BODY>
					<AREA_SEC>
						INIT_EXPR='mainXMLFilter = BooleanQuery (
  checkElementByKey (
    "main-xmls",
    getXMLDocument().id,
    getElementParam("$mainXML")
  )
);

getAttrStringValue("element") != "" ?
{
  element = findElementByKey (
    "xsd-global-elements",
    getAttrQNameValue("element"),
    mainXMLFilter
  );

  thisContext.setVar ("element", element);

  thisContext.setVar (
    "elementType",
    findElementByKey ("xsd-element-types", element.id)
  )
};

getAttrStringValue("type") != "" ?
{
  thisContext.setVar (
    "type",
    findElementByKey (
      "xsd-types",
      getAttrQNameValue("type"),
      mainXMLFilter
    )
  )
}'
						FMT={
							trow.cell.align.vert='Top';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										COND='iterator.isFirstItem'
										TEXT='Parts:'
										FMT={
											ctrl.size.width='44.3';
											ctrl.size.height='18';
											tcell.sizing='Minimal';
											par.style='ps2';
										}
									</TEXT_CTRL>
									<SS_CALL_CTRL>
										SS_NAME='Part Rep'
										FMT={
											ctrl.size.width='455.3';
											ctrl.size.height='18';
											tcell.padding.extra.left='11';
										}
									</SS_CALL_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
	</FOLDER>
</ROOT>
<STOCK_SECTIONS>
	<FOLDER>
		SS_NAME='Part Rep'
		MATCHING_ET='wsdl:part'
		<BODY>
			<FOLDER>
				DESCR='HEADER'
				FMT={
					sec.outputStyle='text-par';
					text.style='cs7';
				}
				<BODY>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<DATA_CTRL>
										ATTR='name'
										FMT={
											text.style='cs5';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("WSDL Definition Link Title")'
											HKEYS={
												'contextElement.id';
												'"detail"';
											}
										</DOC_HLINK>
									</DATA_CTRL>
									<TEXT_CTRL>
										TEXT=':'
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<FOLDER>
						DESCR='content\'s datatype'
						<BODY>
							<FOLDER>
								DESCR='case of element'
								COND='getAttrStringValue("element") != ""'
								BREAK_PARENT_BLOCK='when-executed'
								<BODY>
									<AREA_SEC>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='element'
														FMT={
															text.style='cs2';
														}
													</TEXT_CTRL>
													<DATA_CTRL>
														ATTR='element'
														FMT={
															text.style='cs5';
														}
														<DOC_HLINK>
															CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("element")'
															MATCHING_ET='xs:element'
															TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("XSD Component Link Title")'
															HKEYS={
																'contextElement.id';
																'"detail"';
															}
														</DOC_HLINK>
													</DATA_CTRL>
													<PANEL>
														COND='output.format.supportsPageRefs
&&
getBooleanParam("page.refs")
&&
findHyperTarget (Array (
  thisContext.getElementVar("element").id,
  "detail"
)) != null'
														FMT={
															ctrl.size.width='145.5';
															ctrl.size.height='38.3';
															text.style='cs6';
															txtfl.separator.type='none';
														}
														<AREA>
															<CTRL_GROUP>
																<CTRLS>
																	<TEXT_CTRL>
																		TEXT='['
																	</TEXT_CTRL>
																	<DATA_CTRL>
																		DOCFIELD='page-htarget'
																		FMT={
																			ctrl.option.noHLinkFmt='true';
																			text.hlink.fmt='none';
																		}
																		<DOC_HLINK>
																			CONTEXT_ELEMENT_EXPR='thisContext.getElementVar("element")'
																			MATCHING_ET='xs:element'
																			HKEYS={
																				'contextElement.id';
																				'"detail"';
																			}
																		</DOC_HLINK>
																	</DATA_CTRL>
																	<TEXT_CTRL>
																		TEXT=']'
																	</TEXT_CTRL>
																</CTRLS>
															</CTRL_GROUP>
														</AREA>
													</PANEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
									<FOLDER>
										DESCR='element\'s type'
										CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("elementType")'
										MATCHING_ETS={'#CUSTOM';'xs:complexType';'xs:simpleType'}
										<HEADER>
											<AREA_SEC>
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																TEXT='of'
															</TEXT_CTRL>
															<TEXT_CTRL>
																TEXT='type'
																FMT={
																	text.style='cs2';
																}
															</TEXT_CTRL>
															<SEPARATOR>
															</SEPARATOR>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
										</HEADER>
										<BODY>
											<AREA_SEC>
												DESCR='when the type reference is not resolved'
												MATCHING_ET='#CUSTOM'
												BREAK_PARENT_BLOCK='when-executed'
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<DATA_CTRL>
																MATCHING_ET='#CUSTOM'
																EXPR='contextElement.value.toQName().toXMLName (rootElement)'
																FMT={
																	text.style='cs5';
																}
															</DATA_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
											<AREA_SEC>
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<SS_CALL_CTRL>
																SS_NAME='XSD Component Name'
																FMT={
																	text.style='cs5';
																	txtfl.separator.type='text';
																	txtfl.separator.text=', ';
																}
															</SS_CALL_CTRL>
															<PANEL>
																COND='output.format.supportsPageRefs
&&
getBooleanParam("page.refs")
&&
findHyperTarget (Array (
  contextElement.id,
  "detail"
)) != null'
																FMT={
																	ctrl.size.width='145.5';
																	ctrl.size.height='38.3';
																	text.style='cs6';
																	txtfl.separator.type='none';
																}
																<AREA>
																	<CTRL_GROUP>
																		<CTRLS>
																			<TEXT_CTRL>
																				TEXT='['
																			</TEXT_CTRL>
																			<DATA_CTRL>
																				DOCFIELD='page-htarget'
																				FMT={
																					ctrl.option.noHLinkFmt='true';
																					text.hlink.fmt='none';
																				}
																				<DOC_HLINK>
																					HKEYS={
																						'contextElement.id';
																						'"detail"';
																					}
																				</DOC_HLINK>
																			</DATA_CTRL>
																			<TEXT_CTRL>
																				TEXT=']'
																			</TEXT_CTRL>
																		</CTRLS>
																	</CTRL_GROUP>
																</AREA>
															</PANEL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
										</BODY>
									</FOLDER>
								</BODY>
							</FOLDER>
							<FOLDER>
								DESCR='case of type'
								COND='getAttrStringValue("type") != ""'
								BREAK_PARENT_BLOCK='when-executed'
								<BODY>
									<AREA_SEC>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='type'
														FMT={
															text.style='cs2';
														}
													</TEXT_CTRL>
													<DATA_CTRL>
														ATTR='type'
														FMT={
															text.style='cs5';
														}
														<DOC_HLINK>
															CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("type")'
															MATCHING_ETS={'xs:complexType';'xs:simpleType'}
															TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("XSD Component Link Title")'
															HKEYS={
																'contextElement.id';
																'"detail"';
															}
														</DOC_HLINK>
													</DATA_CTRL>
													<PANEL>
														COND='output.format.supportsPageRefs
&&
getBooleanParam("page.refs")
&&
findHyperTarget (Array (
  thisContext.getElementVar("type").id,
  "detail"
)) != null'
														FMT={
															ctrl.size.width='145.5';
															ctrl.size.height='38.3';
															text.style='cs6';
															txtfl.separator.type='none';
														}
														<AREA>
															<CTRL_GROUP>
																<CTRLS>
																	<TEXT_CTRL>
																		TEXT='['
																	</TEXT_CTRL>
																	<DATA_CTRL>
																		DOCFIELD='page-htarget'
																		FMT={
																			ctrl.option.noHLinkFmt='true';
																			text.hlink.fmt='none';
																		}
																		<DOC_HLINK>
																			CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("type")'
																			MATCHING_ETS={'xs:complexType';'xs:simpleType'}
																			HKEYS={
																				'contextElement.id';
																				'"detail"';
																			}
																		</DOC_HLINK>
																	</DATA_CTRL>
																	<TEXT_CTRL>
																		TEXT=']'
																	</TEXT_CTRL>
																</CTRLS>
															</CTRL_GROUP>
														</AREA>
													</PANEL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
								</BODY>
							</FOLDER>
							<AREA_SEC>
								DESCR='neither \'element\' nor \'type\' attribute provided'
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<TEXT_CTRL>
												TEXT='???'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</FOLDER>
				</BODY>
			</FOLDER>
			<FOLDER>
				DESCR='DESCRIPTION'
				COND='getBooleanParam("parts.description")'
				FMT={
					sec.spacing.before='7';
					text.style='cs3';
				}
				<BODY>
					<SS_CALL>
						DESCR='if this part has its own description'
						BREAK_PARENT_BLOCK='when-output'
						SS_NAME='WSDL Documentation'
					</SS_CALL>
					<FOLDER>
						DESCR='otherwise, copy description from the part\'s data type'
						COND='getBooleanParam("parts.description.copyFrom.dataType")'
						<BODY>
							<FOLDER>
								DESCR='in case of \'element\' attribute, copy the annotation from the referenced XSD element or its type'
								COND='getAttrStringValue("element") != ""'
								FMT={
									sec.spacing.before='7';
								}
								<BODY>
									<FOLDER>
										DESCR='annotation copied from the referenced XSD element'
										BREAK_PARENT_BLOCK='when-output'
										<HEADER>
											<AREA_SEC>
												FMT={
													text.font.style.bold='true';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																TEXT='Description copied from element:'
															</TEXT_CTRL>
															<DATA_CTRL>
																ATTR='element'
																FMT={
																	text.style='cs5';
																}
																<DOC_HLINK>
																	CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("element")'
																	MATCHING_ET='xs:element'
																	TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("XSD Component Link Title")'
																	HKEYS={
																		'contextElement.id';
																		'"detail"';
																	}
																</DOC_HLINK>
															</DATA_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
										</HEADER>
										<BODY>
											<SS_CALL>
												SS_NAME='XSD Annotation'
												PASSED_ELEMENT_EXPR='thisContext.getElementVar ("element")'
												PASSED_ELEMENT_MATCHING_ET='xs:element'
											</SS_CALL>
										</BODY>
									</FOLDER>
									<FOLDER>
										DESCR='if no output produced, try to copied the annotation of the element\'s type'
										CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("elementType")'
										MATCHING_ETS={'xs:%complexType';'xs:%simpleType'}
										<HEADER>
											<AREA_SEC>
												MATCHING_ETS={'xs:complexType';'xs:simpleType'}
												BREAK_PARENT_BLOCK='when-executed'
												FMT={
													text.font.style.bold='true';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																TEXT='Description copied from type:'
															</TEXT_CTRL>
															<SS_CALL_CTRL>
																SS_NAME='XSD Component Name'
																FMT={
																	text.style='cs5';
																	txtfl.separator.type='text';
																	txtfl.separator.text=', ';
																}
															</SS_CALL_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
											<AREA_SEC>
												CONTEXT_ELEMENT_EXPR='sectionBlock.parentBlock.contextElement'
												MATCHING_ET='wsdl:part'
												FMT={
													text.font.style.bold='true';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																TEXT='Annotation copied from type of element:'
																FMT={
																	text.font.style.bold='true';
																}
															</TEXT_CTRL>
															<DATA_CTRL>
																ATTR='element'
																FMT={
																	text.style='cs5';
																}
																<DOC_HLINK>
																	CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("element")'
																	MATCHING_ET='xs:element'
																	TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("XSD Component Link Title")'
																	HKEYS={
																		'contextElement.id';
																		'"detail"';
																	}
																</DOC_HLINK>
															</DATA_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</AREA_SEC>
										</HEADER>
										<BODY>
											<SS_CALL>
												SS_NAME='XSD Annotation'
											</SS_CALL>
										</BODY>
									</FOLDER>
								</BODY>
							</FOLDER>
							<FOLDER>
								DESCR='in case of \'type\' attribute, copy the annotation from the referenced XSD type'
								COND='getAttrStringValue("type") != ""'
								<HEADER>
									<AREA_SEC>
										FMT={
											text.font.style.bold='true';
										}
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='Description copied from type:'
													</TEXT_CTRL>
													<DATA_CTRL>
														ATTR='type'
														FMT={
															text.style='cs5';
														}
														<DOC_HLINK>
															CONTEXT_ELEMENT_EXPR='thisContext.getElementVar ("type")'
															MATCHING_ETS={'xs:complexType';'xs:simpleType'}
															TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("XSD Component Link Title")'
															HKEYS={
																'contextElement.id';
																'"detail"';
															}
														</DOC_HLINK>
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</AREA_SEC>
								</HEADER>
								<BODY>
									<SS_CALL>
										SS_NAME='XSD Annotation'
										PASSED_ELEMENT_EXPR='thisContext.getElementVar ("type")'
										PASSED_ELEMENT_MATCHING_ETS={'xs:complexType';'xs:simpleType'}
									</SS_CALL>
								</BODY>
							</FOLDER>
						</BODY>
					</FOLDER>
				</BODY>
				<FOOTER>
					COND='! iterator.isLastItem'
					<AREA_SEC>
						<AREA>
							<SPACER>
								FMT={
									spacer.height='5';
									spacer.option.noSuppress='true';
								}
							</SPACER>
						</AREA>
					</AREA_SEC>
				</FOOTER>
			</FOLDER>
		</BODY>
	</FOLDER>
	<ELEMENT_ITER>
		SS_NAME='parts'
		TARGET_ET='wsdl:part'
		SCOPE='simple-location-rules'
		RULES={
			'* -> wsdl:part';
		}
		FMT={
			sec.outputStyle='table';
			table.cell.padding.both='0';
			table.border.style='none';
			table.page.keepTogether='true';
		}
		<BODY>
			<AREA_SEC>
				INIT_EXPR='mainXMLFilter = BooleanQuery (
  checkElementByKey (
    "main-xmls",
    getXMLDocument().id,
    getElementParam("$mainXML")
  )
);

getAttrStringValue("element") != "" ?
{
  element = findElementByKey (
    "xsd-global-elements",
    getAttrQNameValue("element"),
    mainXMLFilter
  );

  thisContext.setVar ("element", element);

  thisContext.setVar (
    "elementType",
    findElementByKey ("xsd-element-types", element.id)
  )
};

getAttrStringValue("type") != "" ?
{
  thisContext.setVar (
    "type",
    findElementByKey (
      "xsd-types",
      getAttrQNameValue("type"),
      mainXMLFilter
    )
  )
}'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<IMAGE_CTRL>
								IMAGE_TYPE='file-image'
								FILE='../../images/messagePart.png'
								OUTPUT_DIR_EXPR='getStringParam("$resourceOutputDir")'
								FMT={
									ctrl.size.width='21';
									ctrl.size.height='18';
									image.alignment='bottom';
									image.padding.right='2';
									tcell.sizing='Minimal';
									tcell.width='16';
									tcell.align.vert='Top';
								}
							</IMAGE_CTRL>
							<SS_CALL_CTRL>
								SS_NAME='Part Rep'
								FMT={
									ctrl.size.width='478.5';
									ctrl.size.height='18';
								}
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</ELEMENT_ITER>
	<TEMPLATE_CALL>
		SS_NAME='WSDL Definition Link Title'
		TEMPLATE_FILE='../misc/defLinkTitle.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='WSDL Documentation'
		MATCHING_ET='wsdl:%tDocumented'
		TEMPLATE_FILE='../../doc/docOutput.tpl'
		PASSED_ROOT_ELEMENT_EXPR='findChild("wsdl:documentation")'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='XSD Annotation'
		MATCHING_ET='xs:%annotated'
		TEMPLATE_FILE='../../xsd/ann/annotation.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='XSD Component Link Title'
		TEMPLATE_FILE='../../xsd/component/componentLinkTitle.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='XSD Component Name'
		DESCR='prints the qualified name of any global schema component or local element (passed as the stock-section context element)'
		TEMPLATE_FILE='../../xsd/component/componentName.tpl'
		PASSED_PARAMS={
			'$targetFrame','"detailFrame"';
		}
		FMT={
			sec.outputStyle='text-par';
		}
	</TEMPLATE_CALL>
</STOCK_SECTIONS>
CHECKSUM='3agEpQbBzSN42VJOkZFYx5P7OnwzCVCPjlXy7Xk83kM'
</FLEXDOCXYZ_TEMPLATE>