<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2004-06-21 01:50:00'
LAST_UPDATE='2021-11-28 13:49:11'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-wsdldoc'
APP_NAME='FlexDoc/XML WSDLDoc'
APP_VER='1.2.5'
APP_AUTHOR='Copyright © 2012-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='wsdldoc'
ROOT_ET='xs:schema'
TITLE_EXPR='title = getStringParam("$title");

(parentTitle = getStringParam("windowTitle")) != null
  ? title + " | " + parentTitle : title'
HTML_HEAD_EXPR='title = getStringParam("$title");

(parentTitle = getStringParam("windowTitle")) != null
  ? title = title + " | " + parentTitle;

\'<script type="text/javascript">
    window.onload = function() {
        parent.document.title="\' + encodeJScriptString (title) + \'";
    }
</script>\''
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$mainXML';
		param.type='GOMElement';
		param.defaultValue.expr='findElementByKey ("main-xmls", getXMLDocument().id)';
	}
	PARAM={
		param.name='$nsURI';
		param.title='Namespace URI';
		param.type='string';
		param.defaultValue.expr='getServiceAttr("targetNamespace")';
		param.fixed='true';
	}
	PARAM={
		param.name='$scope';
		param.description='Specifies the scope passed to subtemplates (called from this template):
<ul>
<li>"any" - unspecified</li>
<li>"namespace" - namespace overview</li>
<li>"schema" - schema overview</li>
</ul>';
		param.type='enum';
		param.enum.values='any;namespace;schema';
		param.defaultValue='schema';
		param.fixed='true';
	}
	PARAM={
		param.name='$title';
		param.type='string';
		param.defaultValue.expr='hasServiceAttr("embedded")
?
  "Schema" + getServiceAttr("embeddedSchemaNo") + " in " + getXMLDocument().getAttrValue("xmlName") +
  (output.type == "included" ? " for {" + ((ns = getServiceAttr("targetNamespace")) != "" ? ns : "no namespace") + "}" : "")
: 
  \'Schema "\' + getXMLDocument().getAttrStringValue("xmlName") + \'"\'';
		param.autoPassed='false';
	}
	PARAM={
		param.name='$page.heading.left';
		param.title='Page Heading (on the left)';
		param.type='string';
		param.defaultValue.expr='getParam("$title")';
		param.fixed='true';
	}
	PARAM={
		param.name='windowTitle';
		param.title='Window Title';
		param.type='string';
		param.trimSpaces='true';
		param.collapseSpaces='true';
		param.noEmptyString='true';
	}
	PARAM={
		param.name='gen';
		param.title='Generate Details';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='gen.grouping';
		param.title='Grouping';
		param.title.style.italic='true';
		param.group='true';
	}
	PARAM={
		param.name='gen.grouping.comps';
		param.title='Components';
		param.title.style.italic='true';
		param.type='enum';
		param.enum.values='namespace;file;allcomps';
	}
	PARAM={
		param.name='gen.xsd.schema';
		param.title='Schemas';
		param.title.style.bold='true';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.xsd.schema.overview';
		param.title='Overview';
		param.type='enum';
		param.enum.values='all;xsd_files;none';
	}
	PARAM={
		param.name='gen.xsd.schema.source';
		param.title='XML Source';
		param.type='enum';
		param.enum.values='all;xsd_files;none';
	}
	PARAM={
		param.name='gen.xsd.comp';
		param.title='XSD Components';
		param.title.style.bold='true';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.xsd.comp.element';
		param.title='Elements';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.xsd.comp.complexType';
		param.title='Complex Types';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.xsd.comp.simpleType';
		param.title='Simple Types';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.xsd.comp.group';
		param.title='Element Groups';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.xsd.comp.attribute';
		param.title='Global Attributes';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.xsd.comp.attributeGroup';
		param.title='Attribute Groups';
		param.type='boolean';
	}
	PARAM={
		param.name='doc';
		param.title='Details';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='doc.xsd.schema';
		param.title='Schema';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview';
		param.title='Overview';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile';
		param.title='Schema Profile';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.targetNamespace';
		param.title='Target Namespace';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.version';
		param.title='Version';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.components';
		param.title='Components';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.formDefault';
		param.title='Default NS-Qualified Form';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.blockDefault';
		param.title='Default Block Attribute';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.blockDefault.value';
		param.title='Value';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.blockDefault.meaning';
		param.title='Meaning';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.finalDefault';
		param.title='Default Final Attribute';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.finalDefault.value';
		param.title='Value';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.finalDefault.meaning';
		param.title='Meaning';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.profile.relatedSchemas';
		param.title='Related Schemas';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.annotation';
		param.title='Annotation';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps';
		param.title='XSD Component Summary';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for';
		param.title='Generate For';
		param.title.style.italic='true';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.elements';
		param.title='Elements';
		param.title.style.italic='true';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.elements.local';
		param.title='Local Elements';
		param.title.style.italic='true';
		param.type='enum';
		param.enum.values='all;complexType;none';
		param.enum.displayValues='all;with complex type;none';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.complexTypes';
		param.title='Complex Types';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.simpleTypes';
		param.title='Simple Types';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.groups';
		param.title='Element Groups';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.attributes';
		param.title='Global Attributes';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.for.attributeGroups';
		param.title='Attribute Groups';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.annotation';
		param.title='Annotation';
		param.type='enum';
		param.enum.values='first_sentence;full;none';
		param.enum.displayValues='first sentence;full;none';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile';
		param.title='Component Profile';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.namespace';
		param.title='Namespace';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.type';
		param.title='Type';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.content';
		param.title='Content';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.abstract';
		param.title='Abstract';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.block';
		param.title='Block';
		param.group='true';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.block.value';
		param.title='Value';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.block.meaning';
		param.title='Meaning';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.final';
		param.title='Final';
		param.group='true';
		param.type='enum';
		param.enum.values='any;non_default;none';
		param.enum.displayValues='any;non-default only;none';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.final.value';
		param.title='Value';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.final.meaning';
		param.title='Meaning';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.subst';
		param.title='Subst.Gr';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.subst.heads';
		param.title='List of group heads';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.subst.members';
		param.title='List of group members';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.nillable';
		param.title='Nillable';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.defined';
		param.title='Defined';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.includes';
		param.title='Includes';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.redefines';
		param.title='Redefines';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.redefined';
		param.title='Redefined';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.overview.comps.profile.used';
		param.title='Used';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.xsd.schema.source';
		param.title='XML Source';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='doc.xsd.schema.source.join.overview';
		param.title='Join with Overview';
		param.type='boolean';
	}
	PARAM={
		param.name='nav';
		param.title='Navigation';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='nav.bar';
		param.title='Navigation Bar';
		param.type='boolean';
	}
	PARAM={
		param.name='page';
		param.title='Pagination';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='page.start';
		param.title='Start from new page';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='page.start.schema';
		param.title='Schema Details';
		param.type='boolean';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Description';
		style.id='cs2';
	}
	PAR_STYLE={
		style.name='Detail Heading 1';
		style.id='ps1';
		text.font.name='Arial';
		text.font.size='16';
		text.font.style.bold='true';
		par.margin.top='10';
		par.margin.bottom='10';
	}
	PAR_STYLE={
		style.name='Detail Heading 4';
		style.id='ps2';
		text.font.size='12';
		text.font.style.bold='true';
		par.bkgr.opaque='true';
		par.bkgr.color='#CCCCFF';
		par.border.style='solid';
		par.border.color='#666666';
		par.margin.top='12';
		par.margin.bottom='8';
		par.padding.left='2';
		par.padding.right='2';
		par.padding.top='2';
		par.padding.bottom='2';
		par.page.keepWithNext='true';
	}
	PAR_STYLE={
		style.name='Detail Heading 4 (Level 2)';
		style.id='ps3';
		style.description='This style is used for those section, whose heading must get into Table of Contents. Otherwise, it is the same as the normal \'Detail Heading 4\' style.';
		text.font.size='12';
		text.font.style.bold='true';
		par.bkgr.opaque='true';
		par.bkgr.color='#CCCCFF';
		par.border.style='solid';
		par.border.color='#666666';
		par.margin.top='12';
		par.margin.bottom='8';
		par.padding.left='2';
		par.padding.right='2';
		par.padding.top='2';
		par.padding.bottom='2';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs3';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps4';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Page Header Font';
		style.id='cs4';
		text.font.name='Arial';
		text.font.style.italic='true';
	}
	PAR_STYLE={
		style.name='Summary Heading (Level 2)';
		style.id='ps5';
		style.description='This style is used for those summaries, whose heading must get into Table of Contents. Otherwise, it is the same as the normal \'Summary Heading\' style.';
		text.font.size='12';
		text.font.style.bold='true';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs3';
}
<HTARGET>
	HKEYS={
		'contextElement.id';
		'"detail"';
	}
</HTARGET>
<HTARGET>
	COND='! hasServiceAttr("embedded")'
	HKEYS={
		'getXMLDocument().id';
		'"detail"';
	}
</HTARGET>
<PAGE_HEADER>
	<AREA_SEC>
		FMT={
			text.style='cs4';
		}
		<AREA>
			<CTRL_GROUP>
				FMT={
					par.border.bottom.style='solid';
				}
				<CTRLS>
					<DATA_CTRL>
						EXPR='getStringParam("$page.heading.left")'
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
</PAGE_HEADER>
<ROOT>
	<TEMPLATE_CALL>
		COND='output.type == "document" && output.demoIncomplete'
		TEMPLATE_FILE='../../demo-incomplete.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		DESCR='Navigation Bar'
		COND='output.type == "document" && getBooleanParam("nav.bar")'
		TEMPLATE_FILE='../../navbar.tpl'
		PASSED_PARAMS={
			'$navbar_type','"schema"';
			'$navbar_location','"header"';
		}
	</TEMPLATE_CALL>
	<AREA_SEC>
		FMT={
			par.style='ps1';
		}
		<AREA>
			<PAGE_BREAK>
				COND='getBooleanParam("page.start.schema")'
			</PAGE_BREAK>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						EXPR='getParam("$title")'
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<FOLDER>
		DESCR='SCHEMA OVERVIEW'
		COND='! hasParamValue("gen.xsd.schema.overview", "none")'
		<BODY>
			<TEMPLATE_CALL>
				COND='getBooleanParam("doc.xsd.schema.overview.profile")'
				TEMPLATE_FILE='schemaProfile.tpl'
				PASSED_PARAMS={
					'$schemaOverview','true';
					'doc.frgm.xsd.schemas.profile.targetNamespace','getBooleanParam("doc.xsd.schema.overview.profile.targetNamespace")';
					'doc.frgm.xsd.schemas.profile.version','getBooleanParam("doc.xsd.schema.overview.profile.version")';
					'doc.frgm.xsd.schemas.profile.components','getBooleanParam("doc.xsd.schema.overview.profile.components")';
					'doc.frgm.xsd.schemas.profile.formDefault','getBooleanParam("doc.xsd.schema.overview.profile.formDefault")';
					'doc.frgm.xsd.schemas.profile.blockDefault','getBooleanParam("doc.xsd.schema.overview.profile.blockDefault")';
					'doc.frgm.xsd.schemas.profile.blockDefault.value','getBooleanParam("doc.xsd.schema.overview.profile.blockDefault.value")';
					'doc.frgm.xsd.schemas.profile.blockDefault.meaning','getBooleanParam("doc.xsd.schema.overview.profile.blockDefault.meaning")';
					'doc.frgm.xsd.schemas.profile.finalDefault','getBooleanParam("doc.xsd.schema.overview.profile.finalDefault")';
					'doc.frgm.xsd.schemas.profile.finalDefault.value','getBooleanParam("doc.xsd.schema.overview.profile.finalDefault.value")';
					'doc.frgm.xsd.schemas.profile.finalDefault.meaning','getBooleanParam("doc.xsd.schema.overview.profile.finalDefault.meaning")';
					'doc.frgm.xsd.schemas.profile.relatedSchemas','getBooleanParam("doc.xsd.schema.overview.profile.relatedSchemas")';
				}
				FMT={
					sec.spacing.before='10';
				}
			</TEMPLATE_CALL>
			<FOLDER COLLAPSED='true'>
				DESCR='Annotation'
				COND='getBooleanParam("doc.xsd.schema.overview.annotation")'
				<HTARGET>
					COND='getBooleanParam("nav.bar")'
					HKEYS={
						'contextElement.id';
						'"annotation"';
					}
				</HTARGET>
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										TEXT='Annotation'
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<TEMPLATE_CALL>
						TEMPLATE_FILE='../ann/annotation.tpl'
						FMT={
							text.style='cs2';
						}
					</TEMPLATE_CALL>
				</BODY>
			</FOLDER>
			<FOLDER>
				DESCR='XSD component summary'
				COND='getBooleanParam("doc.xsd.schema.overview.comps")'
				<BODY>
					<TEMPLATE_CALL>
						DESCR='elements'
						COND='getBooleanParam("doc.xsd.schema.overview.comps.for.elements")'
						TEMPLATE_FILE='../element/elementSummary.tpl'
						PASSED_PARAMS={
							'$hyperTargetFirstKey','contextElement.id';
							'doc.frgm.xsd.comps.for.elements','getBooleanParam("doc.xsd.schema.overview.comps.for.elements")';
							'doc.frgm.xsd.comps.for.elements.local','getStringParam("doc.xsd.schema.overview.comps.for.elements.local")';
							'doc.frgm.xsd.comps.sorting','getBooleanParam("doc.xsd.schema.overview.comps.sorting")';
							'doc.frgm.xsd.comps.annotation','getStringParam("doc.xsd.schema.overview.comps.annotation")';
							'doc.frgm.xsd.comps.profile','getBooleanParam("doc.xsd.schema.overview.comps.profile")';
							'doc.frgm.xsd.comps.profile.namespace','getBooleanParam("doc.xsd.schema.overview.comps.profile.namespace")';
							'doc.frgm.xsd.comps.profile.type','getBooleanParam("doc.xsd.schema.overview.comps.profile.type")';
							'doc.frgm.xsd.comps.profile.content','getBooleanParam("doc.xsd.schema.overview.comps.profile.content")';
							'doc.frgm.xsd.comps.profile.abstract','getBooleanParam("doc.xsd.schema.overview.comps.profile.abstract")';
							'doc.frgm.xsd.comps.profile.block','getStringParam("doc.xsd.schema.overview.comps.profile.block")';
							'doc.frgm.xsd.comps.profile.block.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.value")';
							'doc.frgm.xsd.comps.profile.block.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.meaning")';
							'doc.frgm.xsd.comps.profile.final','getStringParam("doc.xsd.schema.overview.comps.profile.final")';
							'doc.frgm.xsd.comps.profile.final.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.value")';
							'doc.frgm.xsd.comps.profile.final.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.meaning")';
							'doc.frgm.xsd.comps.profile.subst','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst")';
							'doc.frgm.xsd.comps.profile.subst.heads','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.heads")';
							'doc.frgm.xsd.comps.profile.subst.members','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.members")';
							'doc.frgm.xsd.comps.profile.nillable','getBooleanParam("doc.xsd.schema.overview.comps.profile.nillable")';
							'doc.frgm.xsd.comps.profile.defined','getBooleanParam("doc.xsd.schema.overview.comps.profile.defined")';
							'doc.frgm.xsd.comps.profile.includes','getBooleanParam("doc.xsd.schema.overview.comps.profile.includes")';
							'doc.frgm.xsd.comps.profile.redefines','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefines")';
							'doc.frgm.xsd.comps.profile.redefined','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefined")';
							'doc.frgm.xsd.comps.profile.used','getBooleanParam("doc.xsd.schema.overview.comps.profile.used")';
						}
						STYLE_OVERRIDES={
							'Summary Heading','ps5';
						}
						FMT={
							sec.spacing.before='10';
						}
					</TEMPLATE_CALL>
					<TEMPLATE_CALL>
						DESCR='complexTypes'
						COND='getBooleanParam("doc.xsd.schema.overview.comps.for.complexTypes")'
						TEMPLATE_FILE='../type/complexTypeSummary.tpl'
						PASSED_PARAMS={
							'doc.frgm.xsd.comps.sorting','getBooleanParam("doc.xsd.schema.overview.comps.sorting")';
							'doc.frgm.xsd.comps.annotation','getStringParam("doc.xsd.schema.overview.comps.annotation")';
							'doc.frgm.xsd.comps.profile','getBooleanParam("doc.xsd.schema.overview.comps.profile")';
							'doc.frgm.xsd.comps.profile.namespace','getBooleanParam("doc.xsd.schema.overview.comps.profile.namespace")';
							'doc.frgm.xsd.comps.profile.type','getBooleanParam("doc.xsd.schema.overview.comps.profile.type")';
							'doc.frgm.xsd.comps.profile.content','getBooleanParam("doc.xsd.schema.overview.comps.profile.content")';
							'doc.frgm.xsd.comps.profile.abstract','getBooleanParam("doc.xsd.schema.overview.comps.profile.abstract")';
							'doc.frgm.xsd.comps.profile.block','getStringParam("doc.xsd.schema.overview.comps.profile.block")';
							'doc.frgm.xsd.comps.profile.block.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.value")';
							'doc.frgm.xsd.comps.profile.block.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.meaning")';
							'doc.frgm.xsd.comps.profile.final','getStringParam("doc.xsd.schema.overview.comps.profile.final")';
							'doc.frgm.xsd.comps.profile.final.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.value")';
							'doc.frgm.xsd.comps.profile.final.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.meaning")';
							'doc.frgm.xsd.comps.profile.subst','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst")';
							'doc.frgm.xsd.comps.profile.subst.heads','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.heads")';
							'doc.frgm.xsd.comps.profile.subst.members','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.members")';
							'doc.frgm.xsd.comps.profile.nillable','getBooleanParam("doc.xsd.schema.overview.comps.profile.nillable")';
							'doc.frgm.xsd.comps.profile.defined','getBooleanParam("doc.xsd.schema.overview.comps.profile.defined")';
							'doc.frgm.xsd.comps.profile.includes','getBooleanParam("doc.xsd.schema.overview.comps.profile.includes")';
							'doc.frgm.xsd.comps.profile.redefines','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefines")';
							'doc.frgm.xsd.comps.profile.redefined','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefined")';
							'doc.frgm.xsd.comps.profile.used','getBooleanParam("doc.xsd.schema.overview.comps.profile.used")';
						}
						STYLE_OVERRIDES={
							'Summary Heading','ps5';
						}
						FMT={
							sec.spacing.before='10';
						}
						<HTARGET>
							HKEYS={
								'contextElement.id';
								'"schema-complexType-summary"';
							}
						</HTARGET>
					</TEMPLATE_CALL>
					<TEMPLATE_CALL>
						DESCR='simpleTypes'
						COND='getBooleanParam("doc.xsd.schema.overview.comps.for.simpleTypes")'
						TEMPLATE_FILE='../type/simpleTypeSummary.tpl'
						PASSED_PARAMS={
							'doc.frgm.xsd.comps.sorting','getBooleanParam("doc.xsd.schema.overview.comps.sorting")';
							'doc.frgm.xsd.comps.annotation','getStringParam("doc.xsd.schema.overview.comps.annotation")';
							'doc.frgm.xsd.comps.profile','getBooleanParam("doc.xsd.schema.overview.comps.profile")';
							'doc.frgm.xsd.comps.profile.namespace','getBooleanParam("doc.xsd.schema.overview.comps.profile.namespace")';
							'doc.frgm.xsd.comps.profile.type','getBooleanParam("doc.xsd.schema.overview.comps.profile.type")';
							'doc.frgm.xsd.comps.profile.content','getBooleanParam("doc.xsd.schema.overview.comps.profile.content")';
							'doc.frgm.xsd.comps.profile.abstract','getBooleanParam("doc.xsd.schema.overview.comps.profile.abstract")';
							'doc.frgm.xsd.comps.profile.block','getStringParam("doc.xsd.schema.overview.comps.profile.block")';
							'doc.frgm.xsd.comps.profile.block.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.value")';
							'doc.frgm.xsd.comps.profile.block.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.meaning")';
							'doc.frgm.xsd.comps.profile.final','getStringParam("doc.xsd.schema.overview.comps.profile.final")';
							'doc.frgm.xsd.comps.profile.final.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.value")';
							'doc.frgm.xsd.comps.profile.final.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.meaning")';
							'doc.frgm.xsd.comps.profile.subst','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst")';
							'doc.frgm.xsd.comps.profile.subst.heads','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.heads")';
							'doc.frgm.xsd.comps.profile.subst.members','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.members")';
							'doc.frgm.xsd.comps.profile.nillable','getBooleanParam("doc.xsd.schema.overview.comps.profile.nillable")';
							'doc.frgm.xsd.comps.profile.defined','getBooleanParam("doc.xsd.schema.overview.comps.profile.defined")';
							'doc.frgm.xsd.comps.profile.includes','getBooleanParam("doc.xsd.schema.overview.comps.profile.includes")';
							'doc.frgm.xsd.comps.profile.redefines','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefines")';
							'doc.frgm.xsd.comps.profile.redefined','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefined")';
							'doc.frgm.xsd.comps.profile.used','getBooleanParam("doc.xsd.schema.overview.comps.profile.used")';
						}
						STYLE_OVERRIDES={
							'Summary Heading','ps5';
						}
						FMT={
							sec.spacing.before='10';
						}
						<HTARGET>
							HKEYS={
								'contextElement.id';
								'"schema-simpleType-summary"';
							}
						</HTARGET>
					</TEMPLATE_CALL>
					<TEMPLATE_CALL>
						DESCR='element groups'
						COND='getBooleanParam("doc.xsd.schema.overview.comps.for.groups")'
						TEMPLATE_FILE='../groups/groupSummary.tpl'
						PASSED_PARAMS={
							'doc.frgm.xsd.comps.sorting','getBooleanParam("doc.xsd.schema.overview.comps.sorting")';
							'doc.frgm.xsd.comps.annotation','getStringParam("doc.xsd.schema.overview.comps.annotation")';
							'doc.frgm.xsd.comps.profile','getBooleanParam("doc.xsd.schema.overview.comps.profile")';
							'doc.frgm.xsd.comps.profile.namespace','getBooleanParam("doc.xsd.schema.overview.comps.profile.namespace")';
							'doc.frgm.xsd.comps.profile.type','getBooleanParam("doc.xsd.schema.overview.comps.profile.type")';
							'doc.frgm.xsd.comps.profile.content','getBooleanParam("doc.xsd.schema.overview.comps.profile.content")';
							'doc.frgm.xsd.comps.profile.abstract','getBooleanParam("doc.xsd.schema.overview.comps.profile.abstract")';
							'doc.frgm.xsd.comps.profile.block','getStringParam("doc.xsd.schema.overview.comps.profile.block")';
							'doc.frgm.xsd.comps.profile.block.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.value")';
							'doc.frgm.xsd.comps.profile.block.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.meaning")';
							'doc.frgm.xsd.comps.profile.final','getStringParam("doc.xsd.schema.overview.comps.profile.final")';
							'doc.frgm.xsd.comps.profile.final.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.value")';
							'doc.frgm.xsd.comps.profile.final.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.meaning")';
							'doc.frgm.xsd.comps.profile.subst','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst")';
							'doc.frgm.xsd.comps.profile.subst.heads','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.heads")';
							'doc.frgm.xsd.comps.profile.subst.members','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.members")';
							'doc.frgm.xsd.comps.profile.nillable','getBooleanParam("doc.xsd.schema.overview.comps.profile.nillable")';
							'doc.frgm.xsd.comps.profile.defined','getBooleanParam("doc.xsd.schema.overview.comps.profile.defined")';
							'doc.frgm.xsd.comps.profile.includes','getBooleanParam("doc.xsd.schema.overview.comps.profile.includes")';
							'doc.frgm.xsd.comps.profile.redefines','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefines")';
							'doc.frgm.xsd.comps.profile.redefined','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefined")';
							'doc.frgm.xsd.comps.profile.used','getBooleanParam("doc.xsd.schema.overview.comps.profile.used")';
						}
						STYLE_OVERRIDES={
							'Summary Heading','ps5';
						}
						FMT={
							sec.spacing.before='10';
						}
						<HTARGET>
							HKEYS={
								'contextElement.id';
								'"schema-group-summary"';
							}
						</HTARGET>
					</TEMPLATE_CALL>
					<TEMPLATE_CALL>
						DESCR='attributes'
						COND='getBooleanParam("doc.xsd.schema.overview.comps.for.attributes")'
						TEMPLATE_FILE='../attribute/attributeSummary.tpl'
						PASSED_PARAMS={
							'doc.frgm.xsd.comps.sorting','getBooleanParam("doc.xsd.schema.overview.comps.sorting")';
							'doc.frgm.xsd.comps.annotation','getStringParam("doc.xsd.schema.overview.comps.annotation")';
							'doc.frgm.xsd.comps.profile','getBooleanParam("doc.xsd.schema.overview.comps.profile")';
							'doc.frgm.xsd.comps.profile.namespace','getBooleanParam("doc.xsd.schema.overview.comps.profile.namespace")';
							'doc.frgm.xsd.comps.profile.type','getBooleanParam("doc.xsd.schema.overview.comps.profile.type")';
							'doc.frgm.xsd.comps.profile.content','getBooleanParam("doc.xsd.schema.overview.comps.profile.content")';
							'doc.frgm.xsd.comps.profile.abstract','getBooleanParam("doc.xsd.schema.overview.comps.profile.abstract")';
							'doc.frgm.xsd.comps.profile.block','getStringParam("doc.xsd.schema.overview.comps.profile.block")';
							'doc.frgm.xsd.comps.profile.block.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.value")';
							'doc.frgm.xsd.comps.profile.block.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.meaning")';
							'doc.frgm.xsd.comps.profile.final','getStringParam("doc.xsd.schema.overview.comps.profile.final")';
							'doc.frgm.xsd.comps.profile.final.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.value")';
							'doc.frgm.xsd.comps.profile.final.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.meaning")';
							'doc.frgm.xsd.comps.profile.subst','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst")';
							'doc.frgm.xsd.comps.profile.subst.heads','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.heads")';
							'doc.frgm.xsd.comps.profile.subst.members','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.members")';
							'doc.frgm.xsd.comps.profile.nillable','getBooleanParam("doc.xsd.schema.overview.comps.profile.nillable")';
							'doc.frgm.xsd.comps.profile.defined','getBooleanParam("doc.xsd.schema.overview.comps.profile.defined")';
							'doc.frgm.xsd.comps.profile.includes','getBooleanParam("doc.xsd.schema.overview.comps.profile.includes")';
							'doc.frgm.xsd.comps.profile.redefines','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefines")';
							'doc.frgm.xsd.comps.profile.redefined','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefined")';
							'doc.frgm.xsd.comps.profile.used','getBooleanParam("doc.xsd.schema.overview.comps.profile.used")';
						}
						STYLE_OVERRIDES={
							'Summary Heading','ps5';
						}
						FMT={
							sec.spacing.before='10';
						}
						<HTARGET>
							HKEYS={
								'contextElement.id';
								'"schema-attribute-summary"';
							}
						</HTARGET>
					</TEMPLATE_CALL>
					<TEMPLATE_CALL>
						DESCR='attribute groups'
						COND='getBooleanParam("doc.xsd.schema.overview.comps.for.attributeGroups")'
						TEMPLATE_FILE='../groups/attributeGroupSummary.tpl'
						PASSED_PARAMS={
							'doc.frgm.xsd.comps.sorting','getBooleanParam("doc.xsd.schema.overview.comps.sorting")';
							'doc.frgm.xsd.comps.annotation','getStringParam("doc.xsd.schema.overview.comps.annotation")';
							'doc.frgm.xsd.comps.profile','getBooleanParam("doc.xsd.schema.overview.comps.profile")';
							'doc.frgm.xsd.comps.profile.namespace','getBooleanParam("doc.xsd.schema.overview.comps.profile.namespace")';
							'doc.frgm.xsd.comps.profile.type','getBooleanParam("doc.xsd.schema.overview.comps.profile.type")';
							'doc.frgm.xsd.comps.profile.content','getBooleanParam("doc.xsd.schema.overview.comps.profile.content")';
							'doc.frgm.xsd.comps.profile.abstract','getBooleanParam("doc.xsd.schema.overview.comps.profile.abstract")';
							'doc.frgm.xsd.comps.profile.block','getStringParam("doc.xsd.schema.overview.comps.profile.block")';
							'doc.frgm.xsd.comps.profile.block.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.value")';
							'doc.frgm.xsd.comps.profile.block.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.block.meaning")';
							'doc.frgm.xsd.comps.profile.final','getStringParam("doc.xsd.schema.overview.comps.profile.final")';
							'doc.frgm.xsd.comps.profile.final.value','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.value")';
							'doc.frgm.xsd.comps.profile.final.meaning','getBooleanParam("doc.xsd.schema.overview.comps.profile.final.meaning")';
							'doc.frgm.xsd.comps.profile.subst','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst")';
							'doc.frgm.xsd.comps.profile.subst.heads','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.heads")';
							'doc.frgm.xsd.comps.profile.subst.members','getBooleanParam("doc.xsd.schema.overview.comps.profile.subst.members")';
							'doc.frgm.xsd.comps.profile.nillable','getBooleanParam("doc.xsd.schema.overview.comps.profile.nillable")';
							'doc.frgm.xsd.comps.profile.defined','getBooleanParam("doc.xsd.schema.overview.comps.profile.defined")';
							'doc.frgm.xsd.comps.profile.includes','getBooleanParam("doc.xsd.schema.overview.comps.profile.includes")';
							'doc.frgm.xsd.comps.profile.redefines','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefines")';
							'doc.frgm.xsd.comps.profile.redefined','getBooleanParam("doc.xsd.schema.overview.comps.profile.redefined")';
							'doc.frgm.xsd.comps.profile.used','getBooleanParam("doc.xsd.schema.overview.comps.profile.used")';
						}
						STYLE_OVERRIDES={
							'Summary Heading','ps5';
						}
						FMT={
							sec.spacing.before='10';
						}
						<HTARGET>
							HKEYS={
								'contextElement.id';
								'"schema-attributeGroup-summary"';
							}
						</HTARGET>
					</TEMPLATE_CALL>
				</BODY>
			</FOLDER>
		</BODY>
	</FOLDER>
	<TEMPLATE_CALL>
		DESCR='SCHEMA SOURCE -- when joined with overview'
		COND='(hasParamValue("gen.xsd.schema.source", "all") ||
 hasParamValue("gen.xsd.schema.source", "xsd_files") && ! hasServiceAttr ("embedded"))
&&
getBooleanParam("doc.xsd.schema.source.join.overview")'
		TEMPLATE_FILE='schema-source.tpl'
		STYLE_OVERRIDES={
			'Detail Heading 4','ps3';
		}
	</TEMPLATE_CALL>
	<FOLDER>
		DESCR='COMPONENT DETAIL -- when components are grouped by schemas (only in case of single-file documentation)'
		COND='output.type == "included"
&&
hasParamValue("gen.grouping.comps", "file")
&&
getBooleanParam("gen.xsd.comp")'
		<BODY>
			<TEMPLATE_CALL>
				DESCR='elements'
				COND='getBooleanParam("gen.xsd.comp.element")'
				TEMPLATE_FILE='../element/elements.tpl'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='complexTypes'
				COND='getBooleanParam("gen.xsd.comp.complexType")'
				TEMPLATE_FILE='../type/complexTypes.tpl'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='simpleTypes'
				COND='getBooleanParam("gen.xsd.comp.simpleType")'
				TEMPLATE_FILE='../type/simpleTypes.tpl'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='groups'
				COND='getBooleanParam("gen.xsd.comp.group")'
				TEMPLATE_FILE='../groups/groups.tpl'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='global attributes'
				COND='getBooleanParam("gen.xsd.comp.attribute")'
				TEMPLATE_FILE='../attribute/attributes.tpl'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
			<TEMPLATE_CALL>
				DESCR='attributeGroups'
				COND='getBooleanParam("gen.xsd.comp.attributeGroup")'
				TEMPLATE_FILE='../groups/attributeGroups.tpl'
				FMT={
					sec.spacing.before='18';
				}
			</TEMPLATE_CALL>
		</BODY>
	</FOLDER>
	<TEMPLATE_CALL>
		DESCR='SCHEMA SOURCE -- when separate from overview (only in case of single-file documentation)'
		COND='output.type == "included"
&&
(hasParamValue("gen.xsd.schema.source", "all") ||
 hasParamValue("gen.xsd.schema.source", "xsd_files") && ! hasServiceAttr ("embedded"))
&&
! getBooleanParam("doc.xsd.schema.source.join.overview")'
		TEMPLATE_FILE='schema-source.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		DESCR='Navigation Bar & bottom message'
		COND='output.type == "document"'
		TEMPLATE_FILE='../../navbar-bottom.tpl'
		PASSED_PARAMS={
			'$navbar_type','"schema"';
		}
	</TEMPLATE_CALL>
</ROOT>
CHECKSUM='c9WsC64RAFyjOfb+qS6l0ZgqgbbOjZ4whTpqYEFxuaU'
</FLEXDOCXYZ_TEMPLATE>