<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2007-08-09 02:06:27'
LAST_UPDATE='2021-11-28 13:49:08'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-xsddoc2'
APP_NAME='FlexDoc/XML XSDDoc'
APP_VER='2.9.5'
APP_AUTHOR='Copyright © 2005-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='xsddoc'
ROOT_ET='xs:%wildcard'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$wildcardType';
		param.type='string';
		param.defaultValue.expr='instanceOf("xs:any") ? "element" : "attribute"';
		param.fixed='true';
		param.autoPassed='false';
	}
	PARAM={
		param.name='$brackets';
		param.description='Specify whether to print brackets';
		param.type='boolean';
		param.defaultValue='true';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs2';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps1';
		style.default='true';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs2';
}
<ROOT>
	<ATTR_ITER>
		SCOPE='attr-values'
		ATTR='namespace'
		FMT={
			sec.outputStyle='text-par';
			txtfl.separator.type='nbtxt';
			txtfl.separator.text=';\\n ';
		}
		<HEADER>
			COND='getBooleanParam("$brackets")'
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='{'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<AREA_SEC>
				COND='iterator.value == "##any"'
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='space';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='any'
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='getParam("$wildcardType")'
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT='from any namespace'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='iterator.value == "##other"'
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='space';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='any'
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='getParam("$wildcardType")'
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT='from non-schema namespace'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='iterator.value == "##local"'
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='space';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='any local'
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='getParam("$wildcardType")'
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT='without namespace'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='iterator.value == "##targetNamespace"'
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='space';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='any'
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='getParam("$wildcardType")'
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT='from schema namespace'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='space';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='any'
							</TEXT_CTRL>
							<DATA_CTRL>
								EXPR='getParam("$wildcardType")'
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT='from'
							</TEXT_CTRL>
							<PANEL>
								FMT={
									ctrl.size.width='103';
									ctrl.size.height='38';
									txtfl.separator.type='none';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<TEXT_CTRL>
												TEXT='"'
											</TEXT_CTRL>
											<DATA_CTRL>
												EXPR='iterator.value'
												<URL_HLINK>
													TARGET_FRAME_EXPR='"_blank"'
													URL_EXPR='iterator.value.toString()'
												</URL_HLINK>
											</DATA_CTRL>
											<TEXT_CTRL>
												TEXT='"'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
							<TEXT_CTRL>
								TEXT='namespace'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
		<FOOTER>
			COND='getBooleanParam("$brackets")'
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='}'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</FOOTER>
	</ATTR_ITER>
</ROOT>
CHECKSUM='RIrC6ipt051?PIPDYqibE3DQsmSKdzFYPd0qAX1KdK8'
</FLEXDOCXYZ_TEMPLATE>