<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2012-07-04 03:11:35'
LAST_UPDATE='2021-11-28 13:49:11'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-wsdldoc'
APP_NAME='FlexDoc/XML WSDLDoc'
APP_VER='1.2.5'
APP_AUTHOR='Copyright © 2012-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='wsdldoc'
ROOT_ET='wsdl:definitions'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$wsdlOverview';
		param.description='Indicates that this profile is included in the WSDL File Overview';
		param.type='boolean';
		param.hidden='true';
	}
	PARAM={
		param.name='$resourceOutputDir';
		param.title='documentation resources directory';
		param.type='string';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile';
		param.title='WSDL File Profile';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.targetNamespace';
		param.title='Target Namespace';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.types.schemas';
		param.title='Types / Schemas';
		param.type='enum';
		param.enum.values='list;summary;none';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.defs';
		param.title='WSDL Definitions';
		param.type='boolean';
	}
	PARAM={
		param.name='doc.frgm.wsdl.files.profile.relatedWSDLs';
		param.title='Related WSDL Files';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.icons';
		param.title='Icons';
		param.type='boolean';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.type='boolean';
	}
	PARAM={
		param.name='show.fileLocation';
		param.title='File Locations';
		param.type='boolean';
	}
	PARAM={
		param.name='page';
		param.title='Pagination';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='page.refs';
		param.title='Generate page references';
		param.type='boolean';
		param.defaultValue='true';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Description (Small)';
		style.id='cs2';
		text.font.size='9';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs3';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='Hyperlink (latent)';
		style.id='cs4';
		text.decor.underline='true';
	}
	CHAR_STYLE={
		style.name='Mono (Small)';
		style.id='cs5';
		text.font.name='Courier New';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps1';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Page Reference';
		style.id='cs6';
		text.font.name='Courier New';
		text.font.size='8';
	}
	CHAR_STYLE={
		style.name='Profile Item';
		style.id='cs7';
		style.description='The text of schema/namespace profile item.';
		style.css.className='profileItem';
		text.font.name='Verdana';
		text.font.size='8';
	}
	PAR_STYLE={
		style.name='Profile Item Title';
		style.id='ps2';
		style.description='Formats the title of schema/namespace profile item.

NOTE: Some of such titles can be simultaneously latent hyperlinks (which reveal themselves only when mouse cursor hovers over the heading). So, when rendered in HTML, this style may produce two named CSS rules: one for <div> element (to format the title paragraph) and other for <span> and <a> elements (to format the title text and the hyperlink). At that, in case of hyperlink, any default hyperlink formatting must be suppressed and normal title formatting preserved. That is achieved by specifically setting: no underline; black color';
		style.css.className='profileItemTitle';
		text.font.size='9';
		text.font.style.bold='true';
		text.decor.underline='false';
		text.color.foreground='#000000';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs3';
}
<ROOT>
	<FOLDER>
		DESCR='WSDL file source'
		FMT={
			sec.spacing.before='5';
		}
		<HEADER>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='none';
							par.style='ps2';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='File Source:'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						FMT={
							row.indent.block='true';
							text.style='cs7';
						}
						<CTRLS>
							<SS_CALL_CTRL>
								COND='getBooleanParam("show.fileLocation")'
								SS_NAME='WSDL Name / Location'
								PARAMS_EXPR='Array (true)'
							</SS_CALL_CTRL>
							<PANEL>
								COND='findHyperTarget (
  Array (contextElement.id, "xml-source")
) != null'
								FMT={
									ctrl.size.width='281.3';
									ctrl.size.height='59.3';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='text';
													txtfl.separator.text='; ';
												}
											</SEPARATOR>
											<TEXT_CTRL>
												TEXT='see'
											</TEXT_CTRL>
											<TEXT_CTRL>
												TEXT='XML source'
												<DOC_HLINK>
													HKEYS={
														'contextElement.id';
														'"xml-source"';
													}
												</DOC_HLINK>
											</TEXT_CTRL>
											<PANEL>
												COND='output.format.supportsPageRefs && 
getBooleanParam("page.refs")'
												FMT={
													ctrl.size.width='180';
													ctrl.size.height='38.3';
													txtfl.separator.type='none';
												}
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<SEPARATOR>
																FMT={
																	txtfl.separator.type='nbsp';
																}
															</SEPARATOR>
															<TEXT_CTRL>
																TEXT='['
																FMT={
																	text.style='cs6';
																}
															</TEXT_CTRL>
															<DATA_CTRL>
																DOCFIELD='page-htarget'
																FMT={
																	ctrl.option.noHLinkFmt='true';
																	text.style='cs6';
																	text.hlink.fmt='none';
																}
																<DOC_HLINK>
																	HKEYS={
																		'contextElement.id';
																		'"xml-source"';
																	}
																</DOC_HLINK>
															</DATA_CTRL>
															<TEXT_CTRL>
																TEXT=']'
																FMT={
																	text.style='cs6';
																}
															</TEXT_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
	<AREA_SEC>
		DESCR='Target Namespace'
		COND='getBooleanParam("doc.frgm.wsdl.files.profile.targetNamespace")'
		FMT={
			sec.spacing.before='5';
		}
		<AREA>
			<CTRL_GROUP>
				FMT={
					txtfl.separator.type='none';
					par.style='ps2';
				}
				<CTRLS>
					<TEXT_CTRL>
						TEXT='Target Namespace'
					</TEXT_CTRL>
					<TEXT_CTRL>
						TEXT=':'
					</TEXT_CTRL>
				</CTRLS>
			</CTRL_GROUP>
			<CTRL_GROUP>
				FMT={
					row.indent.block='true';
					text.style='cs5';
				}
				<CTRLS>
					<DATA_CTRL>
						EXPR='(ns = getAttrValue("targetNamespace")) != "" ? ns : "{no namespace}"'
						<DOC_HLINK>
							HKEYS={
								'getAttrValue("targetNamespace")';
								'"detail"';
							}
						</DOC_HLINK>
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<FOLDER>
		DESCR='types / embedded schemas'
		COND='! hasParamValue("doc.frgm.wsdl.files.profile.types.schemas", "none")'
		FMT={
			sec.spacing.before='5';
		}
		<HEADER>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='none';
							par.style='ps2';
						}
						<CTRLS>
							<DATA_CTRL>
								COND='count = countElementsByLPath ("wsdl:types / xs:schema");

count > 0 ? { setVar ("count", count); true } : false'
								EXPR='"Embedded Schemas (" + getVar("count") + ")"'
								FMT={
									text.hlink.fmt='style';
									text.hlink.style='cs4';
									text.hlink.style.use='hover';
								}
								<DOC_HLINK>
									TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
									HKEYS={
										'contextElement.id';
										'"wsdl-schema-summary"';
									}
								</DOC_HLINK>
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT=':'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<ELEMENT_ITER>
				DESCR='schema list'
				COND='hasParamValue("doc.frgm.wsdl.files.profile.types.schemas", "list")'
				BREAK_PARENT_BLOCK='when-executed'
				TARGET_ET='xs:schema'
				SCOPE='advanced-location-rules'
				RULES={
					'* -> wsdl:types/xs:schema';
				}
				FMT={
					sec.outputStyle='list';
					text.style='cs7';
					list.type='delimited';
					list.indent.block='true';
				}
				<BODY>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<DATA_CTRL>
										EXPR='"Schema" + getServiceAttr("embeddedSchemaNo")'
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? 
  callStockSection("Schema Link Title")'
											HKEYS={
												'contextElement.id';
												'"detail"';
											}
										</DOC_HLINK>
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='schema profiles'
				TARGET_ET='xs:schema'
				SCOPE='advanced-location-rules'
				RULES={
					'* -> wsdl:types/xs:schema';
				}
				FMT={
					sec.outputStyle='list';
					list.bullet.image.file='../../images/schema.png';
					list.bullet.image.outputDirExpr='getStringParam("$resourceOutputDir")';
				}
				<BODY>
					<FOLDER>
						FMT={
							li.margin.top='5';
						}
						<BODY>
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<DATA_CTRL>
												EXPR='"Schema" + getServiceAttr("embeddedSchemaNo")'
												FMT={
													text.style='cs7';
													text.font.style.bold='true';
												}
												<DOC_HLINK>
													TITLE_EXPR='getBooleanParam("show.linkTitle") ? 
  callStockSection("Schema Link Title")'
													HKEYS={
														'contextElement.id';
														'"detail"';
													}
												</DOC_HLINK>
											</DATA_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
							<TEMPLATE_CALL>
								OUTPUT_CHECKER_EXPR='getValuesByLPath(
  "xs:annotation/xs:documentation//(#TEXT | #CDATA)"
).isBlank() ? -1 : 1'
								TEMPLATE_FILE='../../xsd/ann/firstSentence.tpl'
								PASSED_ROOT_ELEMENT_EXPR='findChild("wsdl:documentation")'
								FMT={
									sec.spacing.before='5';
									text.style='cs2';
								}
							</TEMPLATE_CALL>
							<TEMPLATE_CALL>
								TEMPLATE_FILE='../../xsd/schema/schemaProfile.tpl'
								PASSED_PARAMS={
									'$profileType','"embedded"';
								}
							</TEMPLATE_CALL>
						</BODY>
					</FOLDER>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
	</FOLDER>
	<FOLDER>
		DESCR='WSDL definitions (except types) found in this file'
		COND='getBooleanParam("doc.frgm.wsdl.files.profile.defs")'
		FMT={
			sec.spacing.before='5';
		}
		<HEADER>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						FMT={
							par.style='ps2';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='WSDL Definitions:'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<FOLDER>
				FMT={
					sec.outputStyle='text-par';
					sec.indent.block='true';
					text.style='cs7';
					txtfl.separator.type='text';
					txtfl.separator.text=', ';
				}
				<BODY>
					<AREA_SEC>
						DESCR='global attributes'
						COND='count = countChildren ("wsdl:service");

count > 0 ? { setVar ("count", count); true } : false'
						<AREA>
							<CTRL_GROUP>
								FMT={
									text.spacing.nbsp='true';
									txtfl.separator.type='nbsp';
								}
								<CTRLS>
									<TEXT_CTRL>
										TEXT='services'
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											HKEYS={
												'contextElement.id';
												'"wsdl-service-summary"';
											}
										</DOC_HLINK>
									</TEXT_CTRL>
									<DATA_CTRL>
										EXPR='\'(\' + getVar("count") + \')\''
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						DESCR='global attributes'
						COND='count = countChildren ("wsdl:binding");

count > 0 ? { setVar ("count", count); true } : false'
						<AREA>
							<CTRL_GROUP>
								FMT={
									text.spacing.nbsp='true';
									txtfl.separator.type='nbsp';
								}
								<CTRLS>
									<TEXT_CTRL>
										TEXT='bindings'
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											HKEYS={
												'contextElement.id';
												'"wsdl-binding-summary"';
											}
										</DOC_HLINK>
									</TEXT_CTRL>
									<DATA_CTRL>
										EXPR='\'(\' + getVar("count") + \')\''
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						DESCR='global attributes'
						COND='count = countChildren ("wsdl:portType");

count > 0 ? { setVar ("count", count); true } : false'
						<AREA>
							<CTRL_GROUP>
								FMT={
									text.spacing.nbsp='true';
									txtfl.separator.type='nbsp';
								}
								<CTRLS>
									<TEXT_CTRL>
										TEXT='portTypes'
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											HKEYS={
												'contextElement.id';
												'"wsdl-portType-summary"';
											}
										</DOC_HLINK>
									</TEXT_CTRL>
									<DATA_CTRL>
										EXPR='\'(\' + getVar("count") + \')\''
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
					<AREA_SEC>
						DESCR='global attributes'
						COND='count = countChildren ("wsdl:message");

count > 0 ? { setVar ("count", count); true } : false'
						<AREA>
							<CTRL_GROUP>
								FMT={
									text.spacing.nbsp='true';
									txtfl.separator.type='nbsp';
								}
								<CTRLS>
									<TEXT_CTRL>
										TEXT='messages'
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											HKEYS={
												'contextElement.id';
												'"wsdl-message-summary"';
											}
										</DOC_HLINK>
									</TEXT_CTRL>
									<DATA_CTRL>
										EXPR='\'(\' + getVar("count") + \')\''
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
		</BODY>
	</FOLDER>
	<FOLDER COLLAPSED='true'>
		DESCR='Related WSDL Files'
		COND='getBooleanParam("doc.frgm.wsdl.files.profile.relatedWSDLs")'
		<BODY>
			<ELEMENT_ITER>
				DESCR='imports WSDL files'
				TARGET_ET='wsdl:import'
				SCOPE='simple-location-rules'
				RULES={
					'* -> wsdl:import';
				}
				FILTER='checkElementsByKey ("referenced-xml", contextElement.id)'
				SORTING='by-expr'
				SORTING_KEY={expr='schema = findElementByKey ("referenced-xml", contextElement.id);
schema.getXMLDocument().getAttrStringValue("xmlName")',ascending}
				FMT={
					sec.outputStyle='list';
					sec.spacing.before='5';
					list.type='delimited';
					list.indent.block='true';
				}
				<HEADER>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									par.style='ps2';
								}
								<CTRLS>
									<TEXT_CTRL>
										TEXT='Imports WSDL Files'
									</TEXT_CTRL>
									<DATA_CTRL>
										EXPR='"(" + iterator.numItems + "):"'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='Referenced WSDL'
						PASSED_ELEMENT_EXPR='findElementByKey ("referenced-xml", contextElement.id)'
						PASSED_ELEMENT_MATCHING_ET='wsdl:definitions'
						PARAMS_EXPR='Array (contextElement)'
						FMT={
							text.style='cs7';
						}
					</SS_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='imported by WSDL files'
				TARGET_ET='wsdl:import'
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='findElementsByKey ("xml-references", contextElement.id)'
				SORTING='by-expr'
				SORTING_KEY={expr='getXMLDocument().getAttrStringValue("xmlName")',ascending}
				FMT={
					sec.outputStyle='list';
					sec.spacing.before='5';
					list.type='delimited';
					list.indent.block='true';
				}
				<HEADER>
					<AREA_SEC>
						<AREA>
							<CTRL_GROUP>
								FMT={
									par.style='ps2';
								}
								<CTRLS>
									<TEXT_CTRL>
										TEXT='Imported by WSDL Files'
									</TEXT_CTRL>
									<DATA_CTRL>
										EXPR='"(" + iterator.numItems + "):"'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='Referenced WSDL'
						PASSED_ELEMENT_EXPR='findAncestor("wsdl:definitions")'
						PASSED_ELEMENT_MATCHING_ET='wsdl:definitions'
						PARAMS_EXPR='Array (contextElement)'
						FMT={
							text.style='cs7';
						}
					</SS_CALL>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
	</FOLDER>
</ROOT>
<STOCK_SECTIONS>
	<FOLDER>
		SS_NAME='Referenced WSDL'
		DESCR='param[0] - WSDL reference element (wsdl:import)'
		MATCHING_ET='wsdl:definitions'
		FMT={
			sec.outputStyle='text-par';
		}
		<BODY>
			<AREA_SEC>
				COND='! checkElementsByKey ("documented-wsdl-files", contextElement.id)
&&
getBooleanParam("show.fileLocation")'
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<SEPARATOR>
								FMT={
									txtfl.separator.type='nl';
									txtfl.separator.text=',';
								}
							</SEPARATOR>
							<SS_CALL_CTRL>
								SS_NAME='WSDL Name / Location'
								PARAMS_EXPR='Array (true)'
							</SS_CALL_CTRL>
							<PANEL>
								COND='getBooleanParam("$wsdlOverview")
&&
! output.format.supportsPagination
&&
findHyperTarget (Array (
  stockSection.param.toElement().id,
  "xml-source-location"
)) != null'
								FMT={
									ctrl.size.width='96.8';
									ctrl.size.height='38.3';
									txtfl.separator.type='none';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='nbsp';
												}
											</SEPARATOR>
											<TEXT_CTRL>
												TEXT='['
											</TEXT_CTRL>
											<TEXT_CTRL>
												TEXT='src'
												<DOC_HLINK>
													TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see within schema source"'
													HKEYS={
														'stockSection.param.toElement().id';
														'"xml-source-location"';
													}
												</DOC_HLINK>
											</TEXT_CTRL>
											<TEXT_CTRL>
												TEXT=']'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
							<SEPARATOR>
								FMT={
									txtfl.separator.type='nl';
									txtfl.separator.text=',';
								}
							</SEPARATOR>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<SS_CALL_CTRL>
								SS_NAME='WSDL Name / Location'
								PARAMS_EXPR='Array (false)'
							</SS_CALL_CTRL>
							<PANEL>
								COND='getBooleanParam("$wsdlOverview")
&&
! output.format.supportsPagination
&&
findHyperTarget (Array (
  stockSection.param.toElement().id,
  "xml-source-location"
)) != null'
								FMT={
									ctrl.size.width='96.8';
									ctrl.size.height='38.3';
									txtfl.separator.type='none';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='nbsp';
												}
											</SEPARATOR>
											<TEXT_CTRL>
												TEXT='['
											</TEXT_CTRL>
											<TEXT_CTRL>
												TEXT='src'
												<DOC_HLINK>
													TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see within schema source"'
													HKEYS={
														'stockSection.param.toElement().id';
														'"xml-source-location"';
													}
												</DOC_HLINK>
											</TEXT_CTRL>
											<TEXT_CTRL>
												TEXT=']'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
	<TEMPLATE_CALL>
		SS_NAME='Schema Link Title'
		MATCHING_ET='xs:schema'
		TEMPLATE_FILE='../../xsd/schema/schemaLinkTitle.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='WSDL Link Title'
		MATCHING_ET='wsdl:definitions'
		TEMPLATE_FILE='wsdlLinkTitle.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='WSDL Name / Location'
		DESCR='param[0] - indicates whether to show file location'
		MATCHING_ET='wsdl:definitions'
		TEMPLATE_FILE='wsdlName.tpl'
		PASSED_PARAMS={
			'$showLocation','stockSection.param.toBoolean()';
		}
	</TEMPLATE_CALL>
</STOCK_SECTIONS>
CHECKSUM='gJF7pCshJ49Hb9N8ROD+tD5deu2nfezPbUe64wvuBIA'
</FLEXDOCXYZ_TEMPLATE>