<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2004-06-21 01:50:00'
LAST_UPDATE='2021-11-28 13:49:08'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-xsddoc2'
APP_NAME='FlexDoc/XML XSDDoc'
APP_VER='2.9.5'
APP_AUTHOR='Copyright © 2005-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='xsddoc'
ROOT_ET='xs:schema'
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$mainXSD';
		param.type='GOMElement';
		param.defaultValue.expr='findElementByKey ("main-xsds", getXMLDocument().id)';
	}
	PARAM={
		param.name='$linkDestKeys';
		param.type='string';
		param.list='true';
		param.defaultValue.expr='moveElement (
  Vector ("detail", "xml-source-location"),
  indexOf (
    Array ("details", "xml_source"),
    getStringParam ("nav.listFrame.schema.linkTo")
  ),
  0
).toArray()';
		param.fixed='true';
	}
	PARAM={
		param.name='gen.doc';
		param.title='Generate Details';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='gen.doc.element';
		param.title='Elements';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.doc.element.topLevel';
		param.title='Separate Top-Level Elements';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.doc.element.topLevel.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='gen.doc.element.local';
		param.title='Local Elements';
		param.group='true';
		param.type='enum';
		param.enum.values='all;complexType;none';
	}
	PARAM={
		param.name='gen.doc.element.local.unifyByType';
		param.title='Unify By Type';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='nav';
		param.title='Navigation';
		param.title.style.bold='true';
		param.group='true';
	}
	PARAM={
		param.name='nav.listFrame.toc';
		param.title='Table of Contents';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema';
		param.title='Schema';
		param.title.style.bold='true';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema.linkTo';
		param.title='Link To';
		param.title.style.italic='true';
		param.type='enum';
		param.enum.values='details;xml_source';
	}
	PARAM={
		param.name='nav.listFrame.schema.sorting';
		param.title='Sorting';
		param.title.style.italic='true';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema.elements';
		param.title='Elements';
		param.group='true';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema.elements.local';
		param.title='Local Elements';
		param.type='enum';
		param.enum.values='all;complexType;none';
	}
	PARAM={
		param.name='nav.listFrame.schema.complexTypes';
		param.title='Complex Types';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema.simpleTypes';
		param.title='Simple Types';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema.groups';
		param.title='Element Groups';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema.attributeGroups';
		param.title='Attribute Groups';
		param.type='boolean';
	}
	PARAM={
		param.name='nav.listFrame.schema.attributes';
		param.title='Global Attributes';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.type='boolean';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs1';
		style.default='true';
	}
	PAR_STYLE={
		style.name='Frame Heading 1';
		style.id='ps1';
		text.font.name='Arial';
		text.font.size='9.5';
		text.font.style.bold='true';
		par.margin.bottom='6';
		par.option.nowrap='true';
	}
	PAR_STYLE={
		style.name='Frame Heading 2';
		style.id='ps2';
		text.font.size='9';
		text.font.style.bold='true';
		par.margin.top='6';
		par.margin.bottom='2.5';
		par.option.nowrap='true';
	}
	PAR_STYLE={
		style.name='Frame Heading 2 (Note)';
		style.id='ps3';
		text.font.name='Tahoma';
		text.font.size='6';
		text.font.style.bold='true';
		par.margin.top='0';
		par.margin.bottom='3';
		par.option.nowrap='true';
	}
	PAR_STYLE={
		style.name='Frame Item';
		style.id='ps4';
		text.font.size='9';
		par.option.nowrap='true';
	}
	TABLE_STYLE={
		style.name='Frame TOC Box';
		style.id='ts1';
		table.cell.padding.both='3';
		table.bkgr.color='#F5F5F5';
		table.border.style='solid';
		table.border.color='#999999';
		table.border.css.render='true';
	}
	PAR_STYLE={
		style.name='Frame TOC Item';
		style.id='ps5';
		text.font.size='8';
		par.option.nowrap='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs2';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='Hyperlink (latent)';
		style.id='cs3';
		text.decor.underline='true';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps6';
		style.default='true';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
}
<HTARGET>
	HKEYS={
		'contextElement.id';
		'"listFrame"';
	}
</HTARGET>
<ROOT>
	<FOLDER>
		ALWAYS_PROC_HDRFTR
		<HEADER>
			DESCR='XML schema file name'
			<AREA_SEC>
				FMT={
					par.style='ps1';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<SS_CALL_CTRL>
								SS_NAME='Schema Name'
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='getBooleanParam("nav.listFrame.toc")'
				FMT={
					sec.outputStyle='table';
					table.style='ts1';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<SS_CALL_CTRL>
								SS_NAME='TOC'
								FMT={
									ctrl.size.width='499.5';
									ctrl.size.height='18';
								}
							</SS_CALL_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<FOLDER>
				DESCR='list of elements'
				COND='getBooleanParam("nav.listFrame.schema.elements")'
				<HTARGET>
					HKEYS={
						'rootElement.id';
						'"listFrame"';
						'"elements"';
					}
				</HTARGET>
				<BODY>
					<ELEMENT_ITER>
						DESCR='top-level elements'
						COND='getBooleanParam("gen.doc.element.topLevel")'
						TARGET_ET='xs:element'
						SCOPE='advanced-location-rules'
						RULES={
							'* -> xs:element[getServiceAttr("isTopLevel").toBoolean()]';
						}
						SORTING='by-expr'
						SORTING_KEY={expr='callStockSection("Component Name")',ascending}
						SORTING_COND='getBooleanParam("gen.doc.element.topLevel.sorting")'
						<HEADER>
							<AREA_SEC>
								FMT={
									par.style='ps2';
								}
								<HTARGET>
									HKEYS={
										'rootElement.id';
										'"listFrame"';
										'"top-level-elements"';
									}
								</HTARGET>
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<PANEL>
												FMT={
													ctrl.size.width='216.8';
													ctrl.size.height='38.3';
													text.hlink.fmt='style';
													text.hlink.style='cs3';
													text.hlink.style.use='hover';
												}
												<DOC_HLINK>
													TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  "root element candidates (see summary)"'
													TARGET_FRAME_EXPR='"detailFrame"'
													HKEYS={
														'contextElement.id';
														'"top-level-element-summary"';
													}
												</DOC_HLINK>
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																TEXT='Top-Level Elements'
															</TEXT_CTRL>
															<DATA_CTRL>
																EXPR='"(" + iterator.numItems + ")"'
															</DATA_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</HEADER>
						<BODY>
							<SS_CALL>
								SS_NAME='Component Name'
								FMT={
									par.style='ps4';
								}
							</SS_CALL>
						</BODY>
					</ELEMENT_ITER>
					<ELEMENT_ITER>
						DESCR='other elements'
						TARGET_ET='xs:%element'
						SCOPE='advanced-location-rules'
						RULES={
							'* -> descendant::xs:%element/{// if this is a global element, return it
instanceOf("xs:element") ? return Enum (contextElement);

// if this is a reference to global element, return empty enumeration
getAttrValue("ref") != null ? return null;

// otherwise, it is a local element

// if this local element is documented globally replace it with its unifier
// (when several local elements are unified by type, during the generation 
// all of them are represented by a single local element component -- the unifier -- 
// which may be actually even from a different schema); 
// otherwise, return the same element

el = findElementByKey ("globally-documented-local-elements", contextElement.id);
Enum (el != null ? el : contextElement)}::xs:%element';
						}
						FILTER='instanceOf("xs:element") ?
  ! getBooleanParam("gen.doc.element.topLevel") ||
  ! getServiceAttr ("isTopLevel").toBoolean()
:
// case of local element
{
  // which local elements to list?
  local = getStringParam("nav.listFrame.schema.elements.local");
  
  local == "complexType" ?
    ((typeQName = getAttrQNameValue("type")) != null) ?
      checkElementsByKey (
        "types", typeQName,
        BooleanQuery (
          instanceOf("xs:complexType")
          &&
          checkElementByKey (
            "main-xsds", getXMLDocument().id, getElementParam("$mainXSD")
          )
        )
      )
    : hasChild("xs:complexType")
  :
  local == "all"
}'
						SORTING='by-expr'
						SORTING_KEY={expr='callStockSection("Component Name")',ascending}
						SORTING_COND='getBooleanParam("nav.listFrame.schema.sorting")'
						<HEADER>
							<AREA_SEC>
								INIT_EXPR='! hasParamValue("gen.doc.element.local", "none") &&
getBooleanParam("gen.doc.element.local.unifyByType") ?
{
  elementCount = 0;

  iterate (
    iterator.items,
    @(GOMElement) el,
    FlexQuery ({

      schema_id = rootElement.id;

      count = el.instanceOf ("xs:element") ? 1 :
                countElementsByKey (
                  "globally-documented-local-elements",
                  el.id,
                  BooleanQuery (findAncestor("xs:schema").id == schema_id)
                );

      elementCount = elementCount + (count > 0 ? count : 1);
    })
  )
} : {
  elementCount = iterator.numItems
};

setVar ("elementCount", elementCount);'
								FMT={
									sec.spacing.after='2.5';
									par.style='ps2';
								}
								<HTARGET>
									HKEYS={
										'rootElement.id';
										'"listFrame"';
										'"other-elements"';
									}
								</HTARGET>
								<AREA>
									<CTRL_GROUP>
										FMT={
											par.margin.bottom='0';
										}
										<CTRLS>
											<PANEL>
												FMT={
													ctrl.size.width='409.5';
													ctrl.size.height='38.3';
													text.hlink.fmt='style';
													text.hlink.style='cs3';
													text.hlink.style.use='hover';
												}
												<DOC_HLINK>
													TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
													TARGET_FRAME_EXPR='"detailFrame"'
													HKEYS={
														'contextElement.id';
														'"other-element-summary"';
													}
												</DOC_HLINK>
												<AREA>
													<CTRL_GROUP>
														<CTRLS>
															<TEXT_CTRL>
																COND='hasParamValue("nav.listFrame.schema.elements.local", "all")'
																TEXT='All'
															</TEXT_CTRL>
															<TEXT_CTRL>
																COND='findHyperTarget (
  Array (
    rootElement.id,
    "listFrame",
    "top-level-elements"
  )
) != null'
																TEXT='Other'
															</TEXT_CTRL>
															<TEXT_CTRL>
																COND='hasParamValue("nav.listFrame.schema.elements.local", "none")'
																TEXT='Global'
															</TEXT_CTRL>
															<TEXT_CTRL>
																TEXT='Elements'
															</TEXT_CTRL>
															<TEXT_CTRL>
																TEXT='('
															</TEXT_CTRL>
															<SEPARATOR>
																FMT={
																	txtfl.separator.type='none';
																}
															</SEPARATOR>
															<DATA_CTRL>
																EXPR='iterator.numItems'
															</DATA_CTRL>
															<SEPARATOR>
																FMT={
																	txtfl.separator.type='text';
																	txtfl.separator.text=' / ';
																}
															</SEPARATOR>
															<DATA_CTRL>
																COND='getIntVar("elementCount") != iterator.numItems'
																EXPR='getVar("elementCount")'
															</DATA_CTRL>
															<SEPARATOR>
																FMT={
																	txtfl.separator.type='none';
																}
															</SEPARATOR>
															<TEXT_CTRL>
																TEXT=')'
															</TEXT_CTRL>
														</CTRLS>
													</CTRL_GROUP>
												</AREA>
											</PANEL>
										</CTRLS>
									</CTRL_GROUP>
									<CTRL_GROUP>
										FMT={
											par.style='ps3';
										}
										<CTRLS>
											<TEMPLATE_CALL_CTRL>
												TEMPLATE_FILE='../element/elementListNote.tpl'
												PASSED_PARAMS={
													'$elements.local','getStringParam("nav.listFrame.schema.elements.local")';
													'$elements.local.unifiedByType','getIntVar("elementCount") != iterator.numItems';
												}
											</TEMPLATE_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</HEADER>
						<BODY>
							<SS_CALL>
								SS_NAME='Component Name'
								FMT={
									par.style='ps4';
								}
							</SS_CALL>
						</BODY>
					</ELEMENT_ITER>
				</BODY>
			</FOLDER>
			<ELEMENT_ITER>
				DESCR='list of complex types'
				COND='getBooleanParam("nav.listFrame.schema.complexTypes")'
				TARGET_ET='xs:complexType'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:complexType';
				}
				SORTING='by-compound-key'
				SORTING_KEY={
					{expr='getAttrStringValue("name")',ascending};
					{expr='getServiceAttr("version").toInt()',ascending};
				}
				SORTING_COND='getBooleanParam("nav.listFrame.schema.sorting")'
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<HTARGET>
							HKEYS={
								'rootElement.id';
								'"listFrame"';
								'"complexTypes"';
							}
						</HTARGET>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='191';
											ctrl.size.height='38';
											text.hlink.fmt='style';
											text.hlink.style='cs3';
											text.hlink.style.use='hover';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											TARGET_FRAME_EXPR='"detailFrame"'
											HKEYS={
												'contextElement.id';
												'"complexType-summary"';
											}
										</DOC_HLINK>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='Complex Types'
													</TEXT_CTRL>
													<DATA_CTRL>
														EXPR='"(" + iterator.numItems + ")"'
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='Component Name'
						FMT={
							par.style='ps4';
						}
					</SS_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='list of simple types'
				COND='getBooleanParam("nav.listFrame.schema.simpleTypes")'
				TARGET_ET='xs:simpleType'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:simpleType';
				}
				SORTING='by-compound-key'
				SORTING_KEY={
					{expr='getAttrStringValue("name")',ascending};
					{expr='getServiceAttr("version").toInt()',ascending};
				}
				SORTING_COND='getBooleanParam("nav.listFrame.schema.sorting")'
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<HTARGET>
							HKEYS={
								'rootElement.id';
								'"listFrame"';
								'"simpleTypes"';
							}
						</HTARGET>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='184';
											ctrl.size.height='38';
											text.hlink.fmt='style';
											text.hlink.style='cs3';
											text.hlink.style.use='hover';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											TARGET_FRAME_EXPR='"detailFrame"'
											HKEYS={
												'contextElement.id';
												'"simpleType-summary"';
											}
										</DOC_HLINK>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='Simple Types'
													</TEXT_CTRL>
													<DATA_CTRL>
														EXPR='"(" + iterator.numItems + ")"'
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='Component Name'
						FMT={
							par.style='ps4';
						}
					</SS_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='list of element groups'
				COND='getBooleanParam("nav.listFrame.schema.groups")'
				TARGET_ET='xs:group'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:group';
				}
				SORTING='by-compound-key'
				SORTING_KEY={
					{expr='getAttrStringValue("name")',ascending};
					{expr='getServiceAttr("version").toInt()',ascending};
				}
				SORTING_COND='getBooleanParam("nav.listFrame.schema.sorting")'
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<HTARGET>
							HKEYS={
								'rootElement.id';
								'"listFrame"';
								'"groups"';
							}
						</HTARGET>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='193';
											ctrl.size.height='38';
											text.hlink.fmt='style';
											text.hlink.style='cs3';
											text.hlink.style.use='hover';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											TARGET_FRAME_EXPR='"detailFrame"'
											HKEYS={
												'contextElement.id';
												'"group-summary"';
											}
										</DOC_HLINK>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='Element Groups'
													</TEXT_CTRL>
													<DATA_CTRL>
														EXPR='"(" + iterator.numItems + ")"'
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='Component Name'
						FMT={
							par.style='ps4';
						}
					</SS_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='list of attribute groups'
				COND='getBooleanParam("nav.listFrame.schema.attributeGroups")'
				TARGET_ET='xs:attributeGroup'
				SCOPE='simple-location-rules'
				RULES={
					'* -> descendant::xs:attributeGroup';
				}
				SORTING='by-compound-key'
				SORTING_KEY={
					{expr='getAttrStringValue("name")',ascending};
					{expr='getServiceAttr("version").toInt()',ascending};
				}
				SORTING_COND='getBooleanParam("nav.listFrame.schema.sorting")'
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<HTARGET>
							HKEYS={
								'rootElement.id';
								'"listFrame"';
								'"attributeGroups"';
							}
						</HTARGET>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='190.5';
											ctrl.size.height='38';
											text.hlink.fmt='style';
											text.hlink.style='cs3';
											text.hlink.style.use='hover';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											TARGET_FRAME_EXPR='"detailFrame"'
											HKEYS={
												'contextElement.id';
												'"attributeGroup-summary"';
											}
										</DOC_HLINK>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='Attribute Groups'
													</TEXT_CTRL>
													<DATA_CTRL>
														EXPR='"(" + iterator.numItems + ")"'
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='Component Name'
						FMT={
							par.style='ps4';
						}
					</SS_CALL>
				</BODY>
			</ELEMENT_ITER>
			<ELEMENT_ITER>
				DESCR='list of global attributes'
				COND='getBooleanParam("nav.listFrame.schema.attributes")'
				TARGET_ET='xs:attribute'
				SCOPE='simple-location-rules'
				RULES={
					'* -> xs:attribute';
				}
				SORTING='by-attr'
				SORTING_KEY={lpath='@name',ascending}
				SORTING_COND='getBooleanParam("nav.listFrame.schema.sorting")'
				<HEADER>
					<AREA_SEC>
						FMT={
							par.style='ps2';
						}
						<HTARGET>
							HKEYS={
								'rootElement.id';
								'"listFrame"';
								'"attributes"';
							}
						</HTARGET>
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<PANEL>
										FMT={
											ctrl.size.width='195';
											ctrl.size.height='38.3';
											text.hlink.fmt='style';
											text.hlink.style='cs3';
											text.hlink.style.use='hover';
										}
										<DOC_HLINK>
											TITLE_EXPR='getBooleanParam("show.linkTitle") ? "see summary"'
											TARGET_FRAME_EXPR='"detailFrame"'
											HKEYS={
												'contextElement.id';
												'"attribute-summary"';
											}
										</DOC_HLINK>
										<AREA>
											<CTRL_GROUP>
												<CTRLS>
													<TEXT_CTRL>
														TEXT='Global Attributes'
													</TEXT_CTRL>
													<DATA_CTRL>
														EXPR='"(" + iterator.numItems + ")"'
													</DATA_CTRL>
												</CTRLS>
											</CTRL_GROUP>
										</AREA>
									</PANEL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</HEADER>
				<BODY>
					<SS_CALL>
						SS_NAME='Component Name'
						FMT={
							par.style='ps4';
						}
					</SS_CALL>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
	</FOLDER>
</ROOT>
<STOCK_SECTIONS>
	<TEMPLATE_CALL>
		SS_NAME='Component Name'
		DESCR='prints the qualified name of any global schema component or local element (passed as the stock-section context element)'
		TEMPLATE_FILE='../component/componentName.tpl'
		PASSED_PARAMS={
			'$targetFrame','"detailFrame"';
		}
		FMT={
			sec.outputStyle='text-par';
		}
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='Schema Name'
		TEMPLATE_FILE='schemaName.tpl'
		PASSED_PARAMS={
			'$targetFrame','"detailFrame"';
		}
	</TEMPLATE_CALL>
	<FOLDER>
		SS_NAME='TOC'
		MATCHING_ET='xs:schema'
		FMT={
			par.style='ps5';
		}
		<BODY>
			<AREA_SEC>
				COND='findHyperTarget (
  Array (
    contextElement.id,
    "listFrame",
    "elements"
  )
) != null'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Elements'
								<DOC_HLINK>
									HKEYS={
										'contextElement.id';
										'"listFrame"';
										'"elements"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
							<PANEL>
								COND='findHyperTarget (
  Array (
    rootElement.id,
    "listFrame",
    "top-level-elements"
  )
) != null'
								FMT={
									ctrl.size.width='144.8';
									txtfl.separator.type='none';
								}
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<TEXT_CTRL>
												TEXT='('
											</TEXT_CTRL>
											<TEXT_CTRL>
												TEXT='top-level'
												<DOC_HLINK>
													HKEYS={
														'rootElement.id';
														'"listFrame"';
														'"top-level-elements"';
													}
												</DOC_HLINK>
											</TEXT_CTRL>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='text';
													txtfl.separator.text=' / ';
												}
											</SEPARATOR>
											<TEXT_CTRL>
												COND='findHyperTarget (
  Array (
    rootElement.id,
    "listFrame",
    "other-elements"
  )
) != null'
												TEXT='other'
												<DOC_HLINK>
													HKEYS={
														'rootElement.id';
														'"listFrame"';
														'"other-elements"';
													}
												</DOC_HLINK>
											</TEXT_CTRL>
											<SEPARATOR>
												FMT={
													txtfl.separator.type='none';
												}
											</SEPARATOR>
											<TEXT_CTRL>
												TEXT=')'
											</TEXT_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</PANEL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='findHyperTarget (
  Array (
    contextElement.id,
    "listFrame",
    "complexTypes"
  )
) != null'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Complex Types'
								<DOC_HLINK>
									HKEYS={
										'contextElement.id';
										'"listFrame"';
										'"complexTypes"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='findHyperTarget (
  Array (
    contextElement.id,
    "listFrame",
    "simpleTypes"
  )
) != null'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Simple Types'
								<DOC_HLINK>
									HKEYS={
										'contextElement.id';
										'"listFrame"';
										'"simpleTypes"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='findHyperTarget (
  Array (
    contextElement.id,
    "listFrame",
    "groups"
  )
) != null'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Element Groups'
								<DOC_HLINK>
									HKEYS={
										'contextElement.id';
										'"listFrame"';
										'"groups"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='findHyperTarget (
  Array (
    contextElement.id,
    "listFrame",
    "attributeGroups"
  )
) != null'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Attribute Groups'
								<DOC_HLINK>
									HKEYS={
										'contextElement.id';
										'"listFrame"';
										'"attributeGroups"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<AREA_SEC>
				COND='findHyperTarget (
  Array (
    contextElement.id,
    "listFrame",
    "attributes"
  )
) != null'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<TEXT_CTRL>
								TEXT='Global Attributes'
								<DOC_HLINK>
									HKEYS={
										'contextElement.id';
										'"listFrame"';
										'"attributes"';
									}
								</DOC_HLINK>
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
</STOCK_SECTIONS>
CHECKSUM='rTiyOnjqT1OwRYpPoxG3xwV1WuF9++uoQnlzAploUZE'
</FLEXDOCXYZ_TEMPLATE>